let list_zone = {};

function modal_r_device_new() {
    // Добавление новго Радиоканального устрйоства и сохранения в конфигурацию
    let nameDevice = document.getElementById("modal_r_device_name").value;

    pick_new_XXAD(); // поиск свободного XXAD и его запись

    $.hide("#modal_r_device");

    createVirtualTable();
    render_VIRTUAL_XXAD();

    //searchKey_XXAD(); // Обновляем таблицу устройств
    //render_searchKey_ZONE(); // Поиск и рендер зон на одноименной закладке
    renderControl(); // Рендерим контролы    
}

function pick_new_XXAD() {
    let nameNewDevice = document.getElementById("modal_r_device_name").value;
    let zoneNumbers = 0; // количество зон датчика

    if (nameNewDevice == "15130") {
        zoneNumbers = 2;
    } else if (nameNewDevice == "16270" || nameNewDevice == "16370") {
        zoneNumbers = 0;
    } else {
        zoneNumbers = 1;
    }    

    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key.indexOf("xxad") != -1) {
            if (deviceJSON.config[i].key != "xxad0") {
                if (deviceJSON.config[i].subvalues[1].value == "" || deviceJSON.config[i].subvalues[1].value == " ") {
                    deviceJSON.config[i].subvalues[0].value = R_DEVICE_NAME[nameNewDevice].type; // Тип устройства
                    deviceJSON.config[i].subvalues[1].value = nameNewDevice; // Название устройства
                    deviceJSON.config[i].subvalues[2].value = "0"; // Серийный номер
                    saveConfig(deviceJSON.config[i]);
                    pick_new_XXDR(deviceJSON.config[i].key, zoneNumbers); // Записываем ключ в XXDR          
                    break;
                }
            }
        }
    }
}

function pick_new_XXDR(key, zone) {    
    let nameKeyXXDR = 'xxdr' + key.slice(4);
    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key.indexOf(nameKeyXXDR) != -1) {
            let nameDevice = document.getElementById("modal_r_device_name").value;
            if (nameDevice === "15130") {
                deviceJSON.config[i].subvalues[0].value = document.getElementById("adresZone_1").value; // Привязка к 1 разделу
                deviceJSON.config[i].subvalues[1].value = document.getElementById("adresZone_2").value; // Привязка ко 2 разделу        
                pick_new_LW(deviceJSON.config[i]); //записываем настройки ЗОНЫ
            } else if (nameDevice === "15230") {
                deviceJSON.config[i].subvalues[0].value = document.getElementById("adresZone_1").value; // Привязка к 1 разделу
                deviceJSON.config[i].subvalues[1].value = ''; // Привязка ко 2 разделу        
            }
            saveConfig(deviceJSON.config[i]);
            break;
        }
    }
}

function pick_new_LW(key) {
    let key1 = key.subvalues[0].value;
    let key2 = key.subvalues[1].value;

    for (var i = 0; i < key.subvalues.length; i++) {
        if (key.subvalues[i].value !== '') {
            let nameKey = 'lw' + key.subvalues[i].value;
            for (k in deviceJSON.config) {
                if (deviceJSON.config[k].key === nameKey) {
                    let idInptType = 'modal_r_device_zone_type_' + (i + 1);
                    let idInptDelay = 'modal_r_device_zone_delay_' + (i + 1);
                    deviceJSON.config[k].subvalues[0].value = "5";
                    deviceJSON.config[k].subvalues[1].value = document.getElementById(idInptType).value;
                    deviceJSON.config[k].subvalues[2].value = document.getElementById(idInptDelay).value;
                    saveConfig(deviceJSON.config[k]);
                }
            }
        }
    }
}

function modal_r_device_new_LW(yz) {
    for (var k = 0; k < yz.length; k++) {
        let LW_NAME = "lw" + yz[k].slice(2);
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key == LW_NAME) {
                let delayId = "modal_r_device_zone_delay_" + (parseInt(k) + parseInt(1));                
                let typeId = "modal_r_device_zone_type_" + (parseInt(k) + parseInt(1));
                let typeZone = document.getElementById(typeId).value;
                typeZone = typeZone.replace("D", "");
                let delay = document.getElementById(delayId).value;

                deviceJSON.config[i].subvalues[0].value = "5";
                deviceJSON.config[i].subvalues[1].value = typeZone;
                deviceJSON.config[i].subvalues[2].value = delay;
                saveConfig(deviceJSON.config[i]);                
            }
        }
    }
}

function modal_r_device_new_XXDR(yzArr, xxaad) {
    if (yzArr == null) {
        let XXDR_NAME = "xxdr" + xxaad.slice(4);
        //let YZ_NAME = yzArr.slice(2);
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf(XXDR_NAME) != -1) {
                deviceJSON.config[i].subvalues[0].value = ""; // номер первого зоны
                deviceJSON.config[i].subvalues[1].value = ""; // номер второй зоны
                saveConfig(deviceJSON.config[i]);
            }
        }
    } else if (yzArr.length == 1) {
        let XXDR_NAME = "xxdr" + xxaad.slice(4);
        let YZ_NAME1 = yzArr[0].slice(2);
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf(XXDR_NAME) != -1) {
                deviceJSON.config[i].subvalues[0].value = YZ_NAME1; // номер первого зоны
                deviceJSON.config[i].subvalues[1].value = ""; // номер второй зоны
                saveConfig(deviceJSON.config[i]);
                break;
            }
        }
    } else if (yzArr.length == 2) {
        let XXDR_NAME = "xxdr" + xxaad.slice(4);
        let YZ_NAME1 = yzArr[0].slice(2);
        let YZ_NAME2 = yzArr[1].slice(2);
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key == XXDR_NAME) {
                deviceJSON.config[i].subvalues[0].value = YZ_NAME1; // номер первого зоны
                deviceJSON.config[i].subvalues[1].value = YZ_NAME2; // номер второй зоны
                saveConfig(deviceJSON.config[i]);
                break;
            }
        }
    }
}


function saveModalIntegrationZone() {
    //Сохранение встроенной зоны
    let CARD_DEVICE = {
        numberZone_1: null, //Номер зоны 1
        typeZone_1: null, //Тип зоны 1        
        delayZone_1: null, // Задержка зоны 1        
        sectionZone_1: null, // Раздел зоны 1        
    }
    // CACHE_EDIT_INTEGRATION_ZONE - номер открытой зоны 

    CARD_DEVICE.numberZone_1 = document.getElementById('adresZone_1') ? document.getElementById('adresZone_1').value : null;
    CARD_DEVICE.typeZone_1 = document.getElementById('modal_r_device_zone_type_1') ? document.getElementById('modal_r_device_zone_type_1').value : null;
    CARD_DEVICE.delayZone_1 = document.getElementById('modal_r_device_zone_delay_1') ? document.getElementById('modal_r_device_zone_delay_1').value : null;
    CARD_DEVICE.sectionZone_1 = document.getElementById('nomberZone_Section_1') ? document.getElementById('nomberZone_Section_1').value : null;

    applySaveIntegrationZone(CARD_DEVICE);
    //let CACHE_EDIT_INTEGRATION_ZONE; // открытая дляредактирования встроенная зона
}

function applySaveIntegrationZone(CARD_DEVICE) {
    // ОТПРАВЛЯЕМ ДАННЫЕ ИЗ КАРТОЧКИ ВСТРОЕННОЙ ЗОНЫ

    let keyLw1 = 'lw' + CARD_DEVICE.numberZone_1; // Ключ номера зоны 1
    let keyYz1 = 'yz' + CARD_DEVICE.numberZone_1; // Ключ номера раздела 1  
    let oldLw = 'lw'+ CACHE_EDIT_INTEGRATION_ZONE; // Старый Ключ номера зоны 1
    let clearOldKey = false; // нужно отчищать старые ключи
    let focusID = false;

    if (CARD_DEVICE.typeZone_1 !== null) {
        CARD_DEVICE.typeZone_1 = CARD_DEVICE.typeZone_1.replace("D", ""); // Убираем из Охр. с фикс. зад. D
        CARD_DEVICE.typeZone_1 = CARD_DEVICE.typeZone_1.replace("noused", "1"); // Заменяем неиспользуемое на 0
    }

    if (CACHE_EDIT_INTEGRATION_ZONE !== CARD_DEVICE.numberZone_1){
        clearOldKey = true;
        for (var k = 0; k < virtualZone.length; k++){
            if (virtualZone[k].numberZone === CARD_DEVICE.numberZone_1){
                if (virtualZone[k].numberZone !== CACHE_EDIT_INTEGRATION_ZONE){
                    console.log('Зона ' + virtualZone[k].numberZone + ' занята устройством ' + virtualZone[k].link.slice(4));
                    document.getElementById('modal_r_device_error').innerHTML = 'Ошибка при сохранении </br> Зона ' + virtualZone[k].numberZone + ' занята устройством ' + virtualZone[k].link.slice(4);
                    $.show('#modal_r_device_error');
                    return
                }
            }
        }

    }

    if (!false) {
        for (i in deviceJSON.config) {

            if (clearOldKey){
                if (deviceJSON.config[i].key === oldLw){
                    deviceJSON.config[i].subvalues[0].value = "0"; // Тип устройства согласно ЕСОП
                    deviceJSON.config[i].subvalues[1].value = "0"; // Модель устройства 
                    deviceJSON.config[i].subvalues[2].value = "0"; // Модель устройства 
                }
                if (deviceJSON.config[i].key === 'zs'){
                    let arrZone = deviceJSON.config[i].subvalues[1].value.split(',');                    
                    for (var l = 0; l < arrZone.length; l++){
                        if (arrZone[l] === CACHE_EDIT_INTEGRATION_ZONE){
                            arrZone[l] = CARD_DEVICE.numberZone_1;
                        }
                    }
                    deviceJSON.config[i].subvalues[1].value = arrZone.join(',');
                    saveConfig(deviceJSON.config[i]);
                }

            }
            
            if (deviceJSON.config[i].key === keyLw1) {
                if (keyLw1 !== 'lw') { //проверяем что ключ зоны корректен          
                    deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.typeZone_1.charAt(0);
                    if (document.getElementById('modal_r_device_zone_type_1').value === 'noused') {
                        deviceJSON.config[i].subvalues[1].value = "0";
                        // если зона не Используется
                    } else {

                        deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.typeZone_1.slice(2);
                    }

                    if (CARD_DEVICE.delayZone_1 === "" || CARD_DEVICE.delayZone_1 === null) {
                        deviceJSON.config[i].subvalues[2].value = "0"; // Если задержка пустая шлем 0
                    } else {
                        deviceJSON.config[i].subvalues[2].value = CARD_DEVICE.delayZone_1;
                    }
                }
                saveConfig(deviceJSON.config[i]);
            }



            if (deviceJSON.config[i].key === keyYz1) {
                deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.sectionZone_1;
                saveConfig(deviceJSON.config[i]);
            }



        }
    }    

    clearExpiredKey();

    parseAppKey("update_notabs");
    closeModalR_dev(); // Чистим кэш и закрывем карточку
    if (focusID) {
        document.getElementById(focusID).scrollIntoView();
    }

}

function saveModalRadio_NEW() {
    // ДОБАВЛЕНИЕ НОВОГО УСТРОЙСТВА
    /* ===========  Сбор данных из карточки устройства  =========================================================================================== */

    let CARD_DEVICE = {
        id: null, //Номер XXAD
        typeDevice: null, //Тип устройства
        numberZone_1: null, //Номер зоны 1
        numberZone_2: null, //Номер зоны 2
        typeZone_1: null, //Тип зоны 1
        typeZone_2: null, //Тип зоны 2
        delayZone_1: null, // Задержка зоны 1
        delayZone_2: null, // Задержка зоны 2
        sectionZone_1: null, // Раздел зоны 1
        sectionZone_2: null, // Раздел зоны 2
        typeESOP: null,
        PARAM_XXSS: null,
        PARAM_XXNB: null
    }

    // ▼ Поиск свободной XXAD ▼
    if (CACHE_EDIT_R_DEVICE.id === '-1') {
        // Если добавляем новое усройство
        let createNewId = false; // проверка подбора xxad
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key.indexOf("xxad") != -1) {
                if (deviceJSON.config[i].key != "xxad0") {
                    if (deviceJSON.config[i].subvalues[1].value == "" || deviceJSON.config[i].subvalues[1].value == " " || deviceJSON.config[i].subvalues[1].value == "0") {
                        CARD_DEVICE.id = deviceJSON.config[i].key;
                        createNewId = true; //подобрали новый XXAD
                        break;
                    }
                }
            }
        }
        if (!createNewId) {
            // проверка подбора xxad
            alertbox.show('Свободные зоны закончились');
        }
    } else if (CACHE_EDIT_R_DEVICE.id === 'thisDevice') {
        // если редактируем встроенную зону        
        return
    } else {
        // Если редактируем устройство
        CARD_DEVICE.id = "xxad" + CACHE_EDIT_R_DEVICE.id;
    }
    // ▼ Тип устройства ▼
    CARD_DEVICE.typeDevice = document.getElementById('modal_r_device_name').value;
    // ▼ Номер зоны 1 ▼
    CARD_DEVICE.numberZone_1 = document.getElementById('adresZone_1') ? document.getElementById('adresZone_1').value : null;
    // ▼ Номер зоны 2 ▼
    CARD_DEVICE.numberZone_2 = document.getElementById('adresZone_2') ? document.getElementById('adresZone_2').value : null;
    // ▼ Тип зоны 1 ▼
    CARD_DEVICE.typeZone_1 = document.getElementById('modal_r_device_zone_type_1') ? document.getElementById('modal_r_device_zone_type_1').value : null;
    // ▼ Тип зоны 2 ▼
    CARD_DEVICE.typeZone_2 = document.getElementById('modal_r_device_zone_type_2') ? document.getElementById('modal_r_device_zone_type_2').value : null;
    // ▼ Задержка зоны 1 ▼
    CARD_DEVICE.delayZone_1 = document.getElementById('modal_r_device_zone_delay_1') ? document.getElementById('modal_r_device_zone_delay_1').value : null;
    // ▼ Задержка зоны 2 ▼
    CARD_DEVICE.delayZone_2 = document.getElementById('modal_r_device_zone_delay_2') ? document.getElementById('modal_r_device_zone_delay_2').value : null;
    // ▼ Раздел зоны 1 ▼
    CARD_DEVICE.sectionZone_1 = document.getElementById('nomberZone_Section_1') ? document.getElementById('nomberZone_Section_1').value : null;
    // ▼ Раздел зоны 2 ▼
    CARD_DEVICE.sectionZone_2 = document.getElementById('nomberZone_Section_2') ? document.getElementById('nomberZone_Section_2').value : null;

    // ▼ ТИП УСТРОЙСТВА СОГЛАСНО ЕСОП ▼
    if (CARD_DEVICE.typeDevice === '15130') {
        CARD_DEVICE.typeESOP = '2';
        if (document.getElementById('sensor_sabotaje').checked) {
            CARD_DEVICE.PARAM_XXSS = '1';
        } else {
            CARD_DEVICE.PARAM_XXSS = '0';
        }

    } else if (CARD_DEVICE.typeDevice === '15230') {
        CARD_DEVICE.typeESOP = '21';
        if (document.getElementById('dal_bol_10_5230').checked) {
            CARD_DEVICE.PARAM_XXSS = '1';
        } else {
            CARD_DEVICE.PARAM_XXSS = '0';
        }

    } else if (CARD_DEVICE.typeDevice === '15231') {
        CARD_DEVICE.typeESOP = '21';
        if (document.getElementById('zveri_on').checked) {
            CARD_DEVICE.PARAM_XXSS = '1';
        } else {
            CARD_DEVICE.PARAM_XXSS = '0';
        }
    } else if (CARD_DEVICE.typeDevice === '15830') {
        CARD_DEVICE.typeESOP = '29';
        let bit_0 = document.getElementById('dist_4_m').checked;
        let bit_1 = document.getElementById('glass_2').checked;
        let bit_2 = document.getElementById('glass_crash').checked;
        CARD_DEVICE.PARAM_XXSS = transformParamSensor(bit_0, bit_1, bit_2);
    } else if (CARD_DEVICE.typeDevice === '16270') {
        CARD_DEVICE.typeESOP = '';
    } else if (CARD_DEVICE.typeDevice === '16370') {
        CARD_DEVICE.typeESOP = '26';
        CARD_DEVICE.PARAM_XXNB = '' + document.getElementById('trinket_fn_clck_0').value + ','
            + document.getElementById('trinket_clc_usr_0').value + ','
            + document.getElementById('trinket_fn_long_clck_0').value + ','
            + document.getElementById('trinket_long_usr_0').value + ';'

            + document.getElementById('trinket_fn_clck_1').value + ','
            + document.getElementById('trinket_clc_usr_1').value + ','
            + document.getElementById('trinket_fn_long_clck_1').value + ','
            + document.getElementById('trinket_long_usr_1').value + ';'

            + document.getElementById('trinket_fn_clck_2').value + ','
            + document.getElementById('trinket_clc_usr_2').value + ','
            + document.getElementById('trinket_fn_long_clck_2').value + ','
            + document.getElementById('trinket_long_usr_2').value + ';'

            + document.getElementById('trinket_fn_clck_3').value + ','
            + document.getElementById('trinket_clc_usr_3').value + ','
            + document.getElementById('trinket_fn_long_clck_3').value + ','
            + document.getElementById('trinket_long_usr_3').value + ';';

    } else if (CARD_DEVICE.typeDevice === '13431') {
        CARD_DEVICE.typeESOP = '91';
        // так же для 3438, 3439 ЕСОП - 91
    }else if (CARD_DEVICE.typeDevice === '17620') {
        CARD_DEVICE.typeESOP = '70';
        // так же для 3438, 3439 ЕСОП - 91
    }
    else {
        CARD_DEVICE.typeESOP = 0;
    }

    /* ======================================================================================================================================== */

    let error = checkNewRadio(CARD_DEVICE); // Проверяем корректность данных

    if (!error.error) {
        // Данные валидны
        $.hide("#modal_r_device_error"); // Скрываем область ошибок
        applyNewRadio(CARD_DEVICE); // Отправляем в ядро
    } else {
        // Выводим ошибку
        let txtError = '<span style="position:inherit; float:right;" onclick=\'$.hide("#modal_r_device_error")\' class="w3-button">×</span>';
        txtError += '<b> &#9888; Ошибка при сохранении:</b> <ul class="w3-ul">';
        for (var i = 0; i < error.listError.length; i++) {
            txtError += "<li>" + error.listError[i].description + '</li>';
        }
        txtError += '</ul>';
        document.getElementById('modal_r_device_error').innerHTML = txtError;
        $.show('#modal_r_device_error'); // отображаем ошибки
        document.getElementById("detailsCard").open = false; // сворачиваем Описание 
    };    
}

function checkNewRadio(CARD_DEVICE) {
    // ПРОВЕРКА КОРРЕКТНОСТИ ДАННЫХ ИЗ КАРТОЧКИ УСТРОЙСТВА
    let RESULT_ERROR = {
        "error": false,
        listError: []
    }
    let description = '';

    // ▼ Проверка названия устройства 
    if (CARD_DEVICE.typeESOP === 0) {
        description = '- Не выбран тип устройства';
        RESULT_ERROR.error = true;
        RESULT_ERROR['listError'].push({
            "nameKey": null,
            "description": description
        })
    }

    /* =====ПРОВЕРЯЕМ НОМЕРА ЗОН====================================== */

    // ▼ Проверка на совпадение номера Основной и Доп зоны ▼
    if (CARD_DEVICE.numberZone_1 === CARD_DEVICE.numberZone_2) {
        if (CARD_DEVICE.numberZone_1 !== null && CARD_DEVICE.numberZone_2 !== null) {
            description = '- Основная и дополнительная зона должны иметь разные номера';
            RESULT_ERROR.error = true;
            RESULT_ERROR['listError'].push({
                "nameKey": null,
                "description": description
            })
        }
    }

    // ▼ Проверка зоны 1 на допустимое значение ▼
    if (+CARD_DEVICE.numberZone_1 > 192 || +CARD_DEVICE.numberZone_1 < 0 || +CARD_DEVICE.numberZone_1 === 0) {
        if (CARD_DEVICE.numberZone_1 !== null) {
            description = '- Номер зоны ' + CARD_DEVICE.numberZone_1 + ' недопустим, введите число от 1 до 192';
            RESULT_ERROR.error = true;
            RESULT_ERROR['listError'].push({
                "nameKey": null,
                "description": description

            })
        }
    }

    // ▼ Проверка зоны 2 на допустимое значение ▼
    // if (+CARD_DEVICE.numberZone_2 > 192 || +CARD_DEVICE.numberZone_2 < 0 || +CARD_DEVICE.numberZone_2 === 0) { БЫЛО ТАК ПОКА НЕ УБРАЛИ ПРОВЕРКУ НА 0 ЗОНУ
    if (+CARD_DEVICE.numberZone_2 > 192 || +CARD_DEVICE.numberZone_2 < 0) {
        if (CARD_DEVICE.numberZone_2 !== null) {
            description = '- Номер зоны ' + CARD_DEVICE.numberZone_2 + ' недопустим, введите число от 1 до 192';
            RESULT_ERROR.error = true;
            RESULT_ERROR['listError'].push({
                "nameKey": null,
                "description": description
            })
        }
    }

    let errorClassSection_1 = false; // Проверка дубль тип/раздел 1
    let errorClassSection_2 = false; // Проверка дубль тип/раздел 1
    let errorDelayZone_1 = false; // Проверка дубль задержка 1
    let errorDelayZone_2 = false; // Проверка дубль задержка 1
    for (var i = 0; i < virtualZone.length; i++) {
        // ▼ Проверка на занятость зоны другим усттройством ▼
        if (virtualZone[i].typeDev != null) {
            if (virtualZone[i].numberZone === CARD_DEVICE.numberZone_1) { // Проверить CARD_DEVICE.id или id
                if (virtualZone[i].link.slice(4) !== CARD_DEVICE.id.slice(4)) {
                    description = '<b><i>- Зона №' + CARD_DEVICE.numberZone_1 + '</b></i> уже используется другим <span style="cursor:help" title="';
                    if (virtualZone[i].typeDev === 'rad') {
                        description += 'Радиоканальное устройство №';
                    } else if (virtualZone[i].typeDev === 'ext') {
                        description += 'Расширитель №';
                    } else {
                        description += 'Устройство №';
                    }
                    description += virtualZone[i].link[virtualZone[i].link.length - 1] + '"><b><i>устройством(?)</i></b></span>, измените номер зоны';
                    RESULT_ERROR.error = true;
                    RESULT_ERROR['listError'].push({
                        "nameKey": null,
                        "description": description
                    })
                }
            } else if (virtualZone[i].numberZone === CARD_DEVICE.numberZone_2 && virtualZone[i].link.slice(4) !== CARD_DEVICE.id.slice(4) && virtualZone[i].typeDev === 'rad') {
                description = '<b><i>- Зона №' + CARD_DEVICE.numberZone_2 + '</b></i> уже используется другим <span style="cursor:help" title="';
                if (virtualZone[i].typeDev === 'rad') {
                    description += 'Радиоканальное устройство №';
                } else if (virtualZone[i].typeDev === 'ext') {
                    description += 'Расширитель №';
                } else {
                    description += 'Устройство №';
                }
                description += virtualZone[i].link[virtualZone[i].link.length - 1] + '"><b><i>устройством(?)</i></b><span>, измените номер зоны';
                RESULT_ERROR.error = true;
                RESULT_ERROR['listError'].push({
                    "nameKey": null,
                    "description": description
                })
            }
            /*
                // ▼ Проверка соответствия типа зоны 1 типу раздела
                if (CARD_DEVICE.sectionZone_1 === virtualZone[i].section) {
                  if (CARD_DEVICE.typeZone_1 !== 'noused') { // убеждаемся что выбран тип зоны
                    let typeZone_1 = CARD_DEVICE['typeZone_1'].charAt(0);   //тип класса раздела    
                    if (typeZone_1 !== virtualZone[i].type) {
                      if (!errorClassSection_1) {
                        errorClassSection_1 = true; // Проверка дубль
                        description = 'Выбранный тип зоны №' + CARD_DEVICE.numberZone_1 + ' не совместим с разделом №' + virtualZone[i].section;
                        RESULT_ERROR.error = true;
                        RESULT_ERROR['listError'].push({
                          "nameKey": null,
                          "description": description
                        })
                      }
                    }
                  }
                }
        
                // ▼ Проверка соответствия типа зоны 2 типу раздела
                if (CARD_DEVICE.sectionZone_2 === virtualZone[i].section) {
                  if (CARD_DEVICE.typeZone_2 !== 'noused') { // убеждаемся что выбран тип зоны
                    let typeZone_2 = CARD_DEVICE['typeZone_2'].charAt(0);   //тип класса раздела    
                    if (typeZone_2 !== virtualZone[i].type) {
                      if (!errorClassSection_2) {
                        errorClassSection_2 = true;
                        description = 'Выбранный тип зоны №' + CARD_DEVICE.numberZone_2 + ' не совместим с разделом №' + virtualZone[i].section;
                        RESULT_ERROR.error = true; // Проверка дубль
                        RESULT_ERROR['listError'].push({
                          "nameKey": null,
                          "description": description
                        })
                      }
                    }
                  }
                }
            */

            // ▼ Проверка задержки 1 на допустимое значение ▼
            if (+CARD_DEVICE.delayZone_1 < 0 || +CARD_DEVICE.delayZone_1 > 180) {
                if (CARD_DEVICE.delayZone_1 !== null) {
                    if (!errorDelayZone_1) {
                        errorDelayZone_1 = true; //проверка на дубль
                        description = '- Задержка для зоны ' + CARD_DEVICE.numberZone_1 + ' недопустима, введите число от 0 до 180';
                        RESULT_ERROR.error = true;
                        RESULT_ERROR['listError'].push({
                            "nameKey": null,
                            "description": description
                        })
                    }
                }
            }

            // ▼ Проверка задержки 2 на допустимое значение ▼
            if (+CARD_DEVICE.delayZone_2 < 0 || +CARD_DEVICE.delayZone_2 > 180) {
                if (CARD_DEVICE.delayZone_2 !== null) {
                    if (!errorDelayZone_2) {
                        errorDelayZone_2 = true; //проверка на дубль
                        description = '- Задержка для зоны ' + CARD_DEVICE.numberZone_2 + ' недопустима, введите число от 0 до 180';
                        RESULT_ERROR.error = true;
                        RESULT_ERROR['listError'].push({
                            "nameKey": null,
                            "description": description
                        })
                    }
                }
            }

        }

        //return RESULT_ERROR
    }
    return RESULT_ERROR
}

function applyNewRadio(CARD_DEVICE) {
    // ОТПРАВЛЯЕМ ДАННЫЕ ИЗ КАРТОЧКИ УСТРОЙСТВА В ЯДРО И ЗАПУСКАЕМ ПОИСК И РЕНДЕР ВСЕХ КЛЮЧЕЙ
    let keyXXDR = 'xxdr' + CARD_DEVICE.id.slice(4);
    let keyXXSS = 'xxss' + CARD_DEVICE.id.slice(4);
    let keyXXNB = 'xxnb' + CARD_DEVICE.id.slice(4);
    let keyLw1 = 'lw' + CARD_DEVICE.numberZone_1; // Ключ номера зоны 1
    let keyLw2 = 'lw' + CARD_DEVICE.numberZone_2; // Ключ номера зоны 2
    let keyYz1 = 'yz' + CARD_DEVICE.numberZone_1; // Ключ номера раздела 1
    let keyYz2 = 'yz' + CARD_DEVICE.numberZone_2; // Ключ номера раздела 2
    let focusID = false;

    if (CARD_DEVICE.sectionZone_1 !== '' && CARD_DEVICE.sectionZone_1 !== null) {
        focusID = "blk_sec_n_" + CARD_DEVICE.sectionZone_1;
    } else if (CARD_DEVICE.sectionZone_2 !== '' && CARD_DEVICE.sectionZone_2 !== null) {
        focusID = "blk_sec_n_" + CARD_DEVICE.sectionZone_2;
    } else {
        focusID = false;
    }

    if (CARD_DEVICE.typeZone_1 !== null) {
        CARD_DEVICE.typeZone_1 = CARD_DEVICE.typeZone_1.replace("D", ""); // Убираем из Охр. с фикс. зад. D
        CARD_DEVICE.typeZone_1 = CARD_DEVICE.typeZone_1.replace("noused", "1"); // Заменяем неиспользуемое на 0
    }
    if (CARD_DEVICE.typeZone_2 !== null) {
        CARD_DEVICE.typeZone_2 = CARD_DEVICE.typeZone_2.replace("D", ""); // Убираем из Охр. с фикс. зад. D  
        CARD_DEVICE.typeZone_2 = CARD_DEVICE.typeZone_2.replace("noused", "1"); // Заменяем неиспользуемое на 0
    }

    if (!false) {
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key === CARD_DEVICE.id) {
                // XXAD
                let serialRadio = '0';
                for (j in virtualRadio) {
                    if (virtualRadio[j].link.slice(4) === CARD_DEVICE.id.slice(4)) {
                        serialRadio = virtualRadio[j].serial;
                    }
                }
                deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.typeESOP; // Тип устройства согласно ЕСОП
                deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.typeDevice; // Модель устройства 
                deviceJSON.config[i].subvalues[2].value = serialRadio; // Serial устройства 
                saveConfig(deviceJSON.config[i]);
            }

            if (deviceJSON.config[i].key === keyXXSS) {
                //XXSS
                if (CARD_DEVICE.PARAM_XXSS != null) {
                    deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.PARAM_XXSS + '';
                    saveConfig(deviceJSON.config[i]);
                }

            }

            if (CARD_DEVICE.PARAM_XXNB !== null) {
                if (deviceJSON.config[i].key === keyXXNB) {
                    //XXNB
                    deviceJSON.config[i].subvalues[0].value = '4';
                    deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.PARAM_XXNB + '';
                    saveConfig(deviceJSON.config[i]);
                }
            }


            if (deviceJSON.config[i].key === keyXXDR) {
                if (deviceJSON.config[i].subvalues[0].value !== CARD_DEVICE.numberZone_1 && deviceJSON.config[i].subvalues[0].value !== '0' && deviceJSON.config[i].subvalues[0].value !== CARD_DEVICE.numberZone_2) {
                    let lwDelete = "lw" + deviceJSON.config[i].subvalues[0].value;
                    let yzDelete = "yz" + deviceJSON.config[i].subvalues[0].value;
                    keyForDelete.push(lwDelete, yzDelete);
                }

                if (deviceJSON.config[i].subvalues[1].value !== CARD_DEVICE.numberZone_2 && deviceJSON.config[i].subvalues[1].value !== '0' && deviceJSON.config[i].subvalues[0].value !== CARD_DEVICE.numberZone_1) {
                    let lwDelete = "lw" + deviceJSON.config[i].subvalues[1].value;
                    let yzDelete = "yz" + deviceJSON.config[i].subvalues[1].value;
                    keyForDelete.push(lwDelete, yzDelete);
                }

                // XXDR
                if (CARD_DEVICE.numberZone_1 !== null) {
                    deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.numberZone_1; // номер зоны 1        
                }

                if (CARD_DEVICE.numberZone_2 !== null) {
                    deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.numberZone_2; // номер зоны 2
                }
                saveConfig(deviceJSON.config[i]);
            }




            if (deviceJSON.config[i].key === keyLw1) {
                if (keyLw1 !== 'lw') { //проверяем что ключ зоны корректен          
                    deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.typeZone_1.charAt(0);
                    if (document.getElementById('modal_r_device_zone_type_1').value === 'noused') {
                        deviceJSON.config[i].subvalues[1].value = "0";
                        // если зона не Используется
                    } else {

                        deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.typeZone_1.slice(2);
                    }

                    if (CARD_DEVICE.delayZone_1 === "" || CARD_DEVICE.delayZone_1 === null) {
                        deviceJSON.config[i].subvalues[2].value = "0"; // Если задержка пустая шлем 0
                    } else {
                        deviceJSON.config[i].subvalues[2].value = CARD_DEVICE.delayZone_1;
                    }
                }
                saveConfig(deviceJSON.config[i]);
            }

            if (deviceJSON.config[i].key === keyLw2) {
                if (keyLw2 !== 'lw') { //проверяем что ключ зоны корректен
                    deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.typeZone_2.charAt(0);

                    if (document.getElementById('modal_r_device_zone_type_1').value === 'noused') {
                        deviceJSON.config[i].subvalues[1].value = "0";
                    } else {
                        // если зона не Используется
                        deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.typeZone_2.slice(2);
                    }

                    if (CARD_DEVICE.delayZone_2 === "" || CARD_DEVICE.delayZone_2 === null) {
                        deviceJSON.config[i].subvalues[2].value = "0"; // Если задержка пустая шлем 0
                    } else {
                        deviceJSON.config[i].subvalues[2].value = CARD_DEVICE.delayZone_2;
                    }
                }
                saveConfig(deviceJSON.config[i]);
            }

            if (deviceJSON.config[i].key === keyYz1) {
                deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.sectionZone_1;
                saveConfig(deviceJSON.config[i]);
            }

            if (deviceJSON.config[i].key === keyYz2) {
                deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.sectionZone_2;
                saveConfig(deviceJSON.config[i]);
            }

        }
    }
    clearExpiredKey();
    parseAppKey("update_notabs");
    closeModalR_dev(); // Чистим кэш и закрывем карточку
    if (focusID) {
        document.getElementById(focusID).scrollIntoView();
    }

}

function clearExpiredKey() {
    let error;
    for (var k = 0; k < keyForDelete.length; k++) {
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key === keyForDelete[k]) {
                if (keyForDelete[k].indexOf("lw") != -1) {
                    console.log("Отчистка ключа " + keyForDelete[k]);
                    deviceJSON.config[i].subvalues[0].value = "0";
                    deviceJSON.config[i].subvalues[1].value = "0";
                    deviceJSON.config[i].subvalues[2].value = "0";
                    saveConfig(deviceJSON.config[i]);
                } else if (keyForDelete[k].indexOf("yz") != -1) {
                    console.log("Отчистка ключа " + keyForDelete[k]);
                    deviceJSON.config[i].subvalues[0].value = "1";
                    saveConfig(deviceJSON.config[i]);
                } else {
                    console.log("Функция отчистки ключа " + keyForDelete[k] + " не описана!!!!!!!!!!");
                }
            }
        }
    }
    keyForDelete = [];
}

function transformParamSensor(param0, param1, param2) {
    if (param2 && param1 && param0) {
        return 7
    } else if (param2 && param1 && !param0) {
        return 6
    } else if (param2 && !param1 && !param0) {
        return 4
    } else if (!param2 && !param1 && !param0) {
        return 0
    } else if (!param2 && !param1 && param0) {
        return 1
    } else if (param2 && !param1 && param0) {
        return 5
    } else if (!param2 && param1 && param0) {
        return 3
    } else if (!param2 && param1 && !param0) {
        return 2
    } else {
        return 7
    }

}




