let RKPS_XXDS = [];

function update_rkps() {
    //alertbox.show('Обновлены данные через радиоканал');

    var xhr = new XMLHttpRequest();
    xhr.open("GET", vhost + "/device?id=" + TUNER_DEVICE_ID + "&configstate=xxds", true);

    xhr.onreadystatechange = function (oEvent) {
        if (xhr.readyState === 4) {
            if (xhr.status === 200) {
                data = JSON.parse(xhr.responseText); // ответ                
                for (i in data.result.config) {
                    if (data.result.config[i].key.indexOf("xxds") != -1) {
                        if (data.result.config[i].subvalues[5].value & 0x10) {
                            let rkps_number = data.result.config[i].key.slice(4); // НОМЕР РК ДАТЧИКА
                            let rkps_dom, value;
                            // НАПРЯЖЕНИЕ ...                    
                            rkps_dom = document.getElementById("rkps_napr_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[0].value + ' мВ';
                                document.getElementById('rkps_napr_' + rkps_number) ? document.getElementById('rkps_napr_' + rkps_number).innerHTML = value : "";
                            }
                            // ...

                            // ТЕМПЕРАТУРА ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[1].value.replace("!", "").replace("*", "-").replace("-0", "0") + ' &#8451;';
                                document.getElementById('rkps_t_' + rkps_number) ? document.getElementById('rkps_t_' + rkps_number).innerHTML = value : "";
                            }
                            // ... ТЕМПЕРАТУРА     

                            // СИГНАЛ ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[2].value;
                                if (value < 140){
                                    value = 0;
                                } else {
                                    value = value - 140;
                                }
                                document.getElementById('rkps_signal_' + rkps_number) ? document.getElementById('rkps_signal_' + rkps_number).innerHTML = value : "";
                            }
                            // ... СИГНАЛ

                            // ПО ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[3].value;
                                document.getElementById('rkps_soft_' + rkps_number) ? document.getElementById('rkps_soft_' + rkps_number).innerHTML = value.charAt(0) + '.' + value.charAt(2) + value.charAt(1) : "";
                            }
                            // ... ПО

                            // ЖЕЛЕЗО ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[4].value;
                                document.getElementById('rkps_hard_' + rkps_number) ? document.getElementById('rkps_hard_' + rkps_number).innerHTML = value.charAt(0) + '.' + value.charAt(1) : "";
                            }
                            // ... ЖЕЛЕЗО

                            // КОРПУС ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x1) {
                                    value = '<span style="color:red">Открыт</span>';
                                } else {
                                    value = '<span style="color:green">Закрыт</span>';
                                }
                                document.getElementById('rkps_corpus_' + rkps_number) ? document.getElementById('rkps_corpus_' + rkps_number).innerHTML = value : "";
                            }
                            // ... КОРПУС

                            // ИНДИКАЦИЯ ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x2) {
                                    value = '<span style="color:green">вкл</span>';
                                } else {
                                    value = 'выкл';
                                }
                                document.getElementById('rkps_indika_' + rkps_number) ? document.getElementById('rkps_indika_' + rkps_number).innerHTML = value : "";
                            }
                            // ... ИНДИКАЦИЯ

                            // ПИТАНИЕ ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x4) {
                                    value = '<span style="color:red">Снижено</span>';
                                } else {
                                    value = '<span style="color:green">Норма</span>';
                                }
                                document.getElementById('rkps_power_' + rkps_number) ? document.getElementById('rkps_power_' + rkps_number).innerHTML = value : "";
                            }
                            // ... ПИТАНИЕ

                            // БАТАРЕЯ 2...                
                            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            // if (rkps_dom) {
                            //     value = data.result.config[i].subvalues[5].value;
                            //     if (value & 0x8) {
                            //         value = '<span style="color:red">Разряжена</span>';
                            //     } else {
                            //         value = '<span style="color:green">Норма</span>';
                            //     }
                            //     document.getElementById('rkps_powerBank_' + rkps_number) ? document.getElementById('rkps_powerBank_' + rkps_number).innerHTML = value : "";
                            // }
                            // ... БАТАРЕЯ 2

                            // ПР запрограммировано ...                
                            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            // if (rkps_dom) {
                            //     value = data.result.config[i].subvalues[5].value;
                            //     if (value & 0x10) {
                            //         value = 'Запрог.';
                            //     } else {
                            //         value = 'Нет';
                            //     }
                            //     document.getElementById('rkps_program_' + rkps_number) ? document.getElementById('rkps_program_' + rkps_number).innerHTML = value : "";
                            // }
                            // ... ПР запрограммировано

                            // ИН инициализировано ...                
                            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            // if (rkps_dom) {
                            //     value = data.result.config[i].subvalues[5].value;
                            //     if (value & 0x40) {
                            //         value = 'Иниц.';
                            //     } else {
                            //         value = 'Не иниц.';
                            //     }
                            //     document.getElementById('rkps_init_' + rkps_number) ? document.getElementById('rkps_init_' + rkps_number).innerHTML = value : "";
                            // }
                            // ... ИН инициализировано

                            // Состояние РУ
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x40) {
                                    //Инициализирован
                                    value = 'Иниц.';
                                } else if (value & 0x10) {
                                    // Запрограммирован
                                    value = 'Запрог.';
                                } else {
                                    // Нет
                                    value = 'Нет';
                                }
                                document.getElementById('rkps_program_' + rkps_number) ? document.getElementById('rkps_program_' + rkps_number).innerHTML = value : "";
                            }
                            // ...Состояние РУ



                            // ПР запрограммировано ...                
                            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            // if (rkps_dom) {
                            //     value = data.result.config[i].subvalues[5].value;
                            //     if (value & 0x20) {
                            //         value = 'Зарег.';
                            //     } else {
                            //         value = 'Не зарег.';
                            //     }
                            //     document.getElementById('rkps_registr_' + rkps_number).innerHTML = value;
                            // }
                            // ... ПР запрограммировано


                            // БЛ заблокировано ...                
                            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            // if (rkps_dom) {
                            //     value = data.result.config[i].subvalues[5].value;
                            //     if (value & 0x80) {
                            //         value = '<span style="color:red">Заблок.</span>';
                            //     } else {
                            //         value = 'Штатно.';
                            //     }
                            //     document.getElementById('rkps_lock_' + rkps_number) ? document.getElementById('rkps_lock_' + rkps_number).innerHTML = value : "";
                            // }
                            // ... БЛ заблокировано

                            // СВЯЗЬ ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x100) {
                                    value = '<span style="color:red">Нет связи</span>';
                                } else {
                                    value = '<span style="color:green">На связи</span>';
                                }
                                document.getElementById('rkps_connect_' + rkps_number) ? document.getElementById('rkps_connect_' + rkps_number).innerHTML = value : "";
                            }
                            // ... СВЯЗЬ

                            // ОСНОВНАЯ ЗОНА НАРУШЕНА ...    
                            value = '';
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            let styleZoneRkps = '';
                            let textNumberZone = ''
                            if (rkps_dom) {
                                let valNmbtZone_1 = rkps_device[rkps_number].zone_1;
                                for (var k = 0; k < virtualZone.length; k++) {
                                    if (data.result.config[i].key.slice(4) == virtualZone[k].link.slice(4) && '1' == virtualZone[k].index) {
                                        if (virtualZone[k].type == '1' && virtualZone[k].param == '0' && virtualZone[k].delay == '0') {
                                            value = 'Зона №' + valNmbtZone_1 + '</br>';
                                            value += 'Исключена'
                                        }
                                    }
                                }
                                if (value !== 'Исключена') {
                                    value = data.result.config[i].subvalues[5].value;

                                    if (value & 0x200) {
                                        //    $.styleRkpsZone(rkps_number, '')                                   
                                        value = '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #f44336; ">' + valNmbtZone_1 + '</div></br>';
                                        value += '<div style="float:left"><span style="">Нарушена</span></div>';
                                    } else {
                                        value = '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #468966; ">' + valNmbtZone_1 + '</div></br>';
                                        value += '<div style="width:80px"><span style="float:left">В норме</span></div>';
                                    }

                                    document.getElementById('rkps_ozn_' + rkps_number) ? document.getElementById('rkps_ozn_' + rkps_number).innerHTML = value : "";
                                    document.getElementById('rkps_ozn_' + rkps_number) ? $.removeClass('.rkps_ozn_' + rkps_number, 'w3-red') : '';
                                } else {
                                    document.getElementById('rkps_ozn_' + rkps_number) ? document.getElementById('rkps_ozn_' + rkps_number).innerHTML = value : "";
                                }
                            }
                            // ... ОСНОВНАЯ ЗОНА НАРУШЕНА

                            // ДОПОЛНИТЕЛЬНАЯ ЗОНА НАРУШЕНА ...    
                            value = '';
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                let valNmbtZone_2 = rkps_device[rkps_number].zone_2;

                                for (var k = 0; k < virtualZone.length; k++) {
                                    if (data.result.config[i].key.slice(4) == virtualZone[k].link.slice(4) && '2' == virtualZone[k].index) {
                                        if (virtualZone[k].type == '1' && virtualZone[k].param == '0' && virtualZone[k].delay == '0') {
                                            value = 'Зона №' + valNmbtZone_2 + '</br>';
                                            value += 'Исключена'
                                        }
                                    }
                                }

                                if (value !== 'Исключена') {
                                    value = data.result.config[i].subvalues[5].value;
                                    textNumberZone = 'Зона №' + valNmbtZone_2 + '</br>';
                                    if (value & 0x400) {
                                        value = '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #f44336; ">' + valNmbtZone_2 + '</div></br>';
                                        value += '<div style="float:left"><span style="">Нарушена</span></div>';
                                    } else {
                                        value = '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #468966; ">' + valNmbtZone_2 + '</div></br>';
                                        value += '<div style="width:80px"><span style="float:left">В норме</span></div>';
                                    }
                                    document.getElementById('rkps_dzn_' + rkps_number) ? document.getElementById('rkps_dzn_' + rkps_number).innerHTML = value : "";
                                } else {
                                    document.getElementById('rkps_dzn_' + rkps_number) ? document.getElementById('rkps_dzn_' + rkps_number).innerHTML = value : "";
                                }

                            }
                            // ... ДОПОЛНИТЕЛЬНАЯ ЗОНА НАРУШЕНА

                            // САБОТАЖ ОСНОВНОЙ ЗОНЫ ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x800) {
                                    value = '<span style="color:red">Саботаж</span>';
                                } else {
                                    value = '';
                                }
                                document.getElementById('rkps_sabotag_' + rkps_number) ? document.getElementById('rkps_sabotag_' + rkps_number).innerHTML = value : "";
                            }
                            // ... САБОТАЖ ОСНОВНОЙ ЗОНЫ

                            // РП резервное питание ...                
                            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            // if (rkps_dom) {
                            //     value = data.result.config[i].subvalues[5].value;
                            //     if (value & 0x1000) {
                            //         value = 'Резерв.';
                            //     } else {
                            //         value = 'Осн.';
                            //     }
                            //     document.getElementById('rkps_rezervpower_' + rkps_number) ? document.getElementById('rkps_rezervpower_' + rkps_number).innerHTML = value : "";
                            // }
                            //... РП резервное питание


                        } else {
                            let rkps_number = data.result.config[i].key.slice(4); // НОМЕР РК ДАТЧИКА
                            document.getElementById('rkps_program_' + rkps_number) ? document.getElementById('rkps_program_' + rkps_number).innerHTML = '<span style="color:red">Нет</span>' : '';
                        }
                    } // До сюда

                }
            }
        }
    }
    xhr.send();
}

function update_rkps_OLD() {
    //alertbox.show('Обновлены данные через радиоканал');

    var xhr = new XMLHttpRequest();
    xhr.open("GET", vhost + "/device?id=" + TUNER_DEVICE_ID + "&configstate=xxds", true);

    xhr.onreadystatechange = function (oEvent) {
        if (xhr.readyState === 4) {
            if (xhr.status === 200) {
                data = JSON.parse(xhr.responseText); // ответ                
                for (i in data.result.config) {
                    if (data.result.config[i].key.indexOf("xxds") != -1) {
                        if (data.result.config[i].subvalues[5].value & 0x10) {
                            let rkps_number = data.result.config[i].key.slice(4); // НОМЕР РК ДАТЧИКА
                            let rkps_dom, value;
                            // НАПРЯЖЕНИЕ ...                    
                            rkps_dom = document.getElementById("rkps_napr_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[0].value + ' мВ';
                                document.getElementById('rkps_napr_' + rkps_number) ? document.getElementById('rkps_napr_' + rkps_number).innerHTML = value : "";
                            }
                            // ...

                            // ТЕМПЕРАТУРА ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[1].value.replace("!", "").replace("*", "-").replace("-0", "0") + ' &#8451;';
                                document.getElementById('rkps_t_' + rkps_number) ? document.getElementById('rkps_t_' + rkps_number).innerHTML = value : "";
                            }
                            // ... ТЕМПЕРАТУРА     

                            // СИГНАЛ ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[2].value;
                                document.getElementById('rkps_signal_' + rkps_number) ? document.getElementById('rkps_signal_' + rkps_number).innerHTML = value : "";
                            }
                            // ... СИГНАЛ

                            // ПО ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[3].value;
                                document.getElementById('rkps_soft_' + rkps_number) ? document.getElementById('rkps_soft_' + rkps_number).innerHTML = value.charAt(0) + '.' + value.charAt(2) + value.charAt(1) : "";
                            }
                            // ... ПО

                            // ЖЕЛЕЗО ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[4].value;
                                document.getElementById('rkps_hard_' + rkps_number) ? document.getElementById('rkps_hard_' + rkps_number).innerHTML = value.charAt(0) + '.' + value.charAt(1) : "";
                            }
                            // ... ЖЕЛЕЗО

                            // КОРПУС ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x1) {
                                    value = '<span style="color:red">Корпус открыт</span>';
                                } else {
                                    value = '<span style="color:green">Корпус закрыт</span>';
                                }
                                document.getElementById('rkps_corpus_' + rkps_number) ? document.getElementById('rkps_corpus_' + rkps_number).innerHTML = value : "";
                            }
                            // ... КОРПУС

                            // ИНДИКАЦИЯ ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x2) {
                                    value = '<span style="color:green">вкл</span>';
                                } else {
                                    value = 'выкл';
                                }
                                document.getElementById('rkps_indika_' + rkps_number) ? document.getElementById('rkps_indika_' + rkps_number).innerHTML = value : "";
                            }
                            // ... ИНДИКАЦИЯ

                            // ПИТАНИЕ ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x4) {
                                    value = 'Резерв.';
                                } else {
                                    value = 'Основ.';
                                }
                                document.getElementById('rkps_power_' + rkps_number) ? document.getElementById('rkps_power_' + rkps_number).innerHTML = value : "";
                            }
                            // ... ПИТАНИЕ

                            // БАТАРЕЯ 2...                
                            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            // if (rkps_dom) {
                            //     value = data.result.config[i].subvalues[5].value;
                            //     if (value & 0x8) {
                            //         value = '<span style="color:red">Разряжена</span>';
                            //     } else {
                            //         value = '<span style="color:green">Норма.</span>';
                            //     }
                            //     document.getElementById('rkps_powerBank_' + rkps_number) ? document.getElementById('rkps_powerBank_' + rkps_number).innerHTML = value : "";
                            // }
                            // ... БАТАРЕЯ 2

                            // ПР запрограммировано ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x10) {
                                    value = 'Запрог.';
                                } else {
                                    value = 'Нет';
                                }
                                document.getElementById('rkps_program_' + rkps_number) ? document.getElementById('rkps_program_' + rkps_number).innerHTML = value : "";
                            }
                            // ... ПР запрограммировано

                            // ПР запрограммировано ...                
                            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            // if (rkps_dom) {
                            //     value = data.result.config[i].subvalues[5].value;
                            //     if (value & 0x20) {
                            //         value = 'Зарег.';
                            //     } else {
                            //         value = 'Не зарег.';
                            //     }
                            //     document.getElementById('rkps_registr_' + rkps_number).innerHTML = value;
                            // }
                            // ... ПР запрограммировано

                            // ИН инициализировано ...                
                            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            // if (rkps_dom) {
                            //     value = data.result.config[i].subvalues[5].value;
                            //     if (value & 0x40) {
                            //         value = 'Иниц.';
                            //     } else {
                            //         value = 'Не иниц.';
                            //     }
                            //     document.getElementById('rkps_init_' + rkps_number) ? document.getElementById('rkps_init_' + rkps_number).innerHTML = value : "";
                            // }
                            // ... ИН инициализировано

                            // БЛ заблокировано ...                
                            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            // if (rkps_dom) {
                            //     value = data.result.config[i].subvalues[5].value;
                            //     if (value & 0x80) {
                            //         value = '<span style="color:red">Заблок.</span>';
                            //     } else {
                            //         value = 'Штатно.';
                            //     }
                            //     document.getElementById('rkps_lock_' + rkps_number) ? document.getElementById('rkps_lock_' + rkps_number).innerHTML = value : "";
                            // }
                            // // ... БЛ заблокировано

                            // СВЯЗЬ ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x100) {
                                    value = '<span style="color:red">Нет связи</span>';
                                } else {
                                    value = '<span style="color:green">На связи</span>';
                                }
                                document.getElementById('rkps_connect_' + rkps_number) ? document.getElementById('rkps_connect_' + rkps_number).innerHTML = value : "";
                            }
                            // ... СВЯЗЬ

                            // ОСНОВНАЯ ЗОНА НАРУШЕНА ...    
                            value = '';
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                for (var k = 0; k < virtualZone.length; k++) {
                                    if (data.result.config[i].key.slice(4) == virtualZone[k].link.slice(4) && '1' == virtualZone[k].index) {
                                        if (virtualZone[k].type == '1' && virtualZone[k].param == '0' && virtualZone[k].delay == '0') {
                                            value = 'Исключена'
                                        }
                                    }
                                }
                                if (value !== 'Исключена') {
                                    value = data.result.config[i].subvalues[5].value;
                                    if (value & 0x200) {
                                        value = '<span style="color:red">Нарушена</span>';
                                    } else {
                                        value = '<span style="color:green">В норме</span>';
                                    }

                                    document.getElementById('rkps_ozn_' + rkps_number) ? document.getElementById('rkps_ozn_' + rkps_number).innerHTML = value : "";
                                } else {
                                    document.getElementById('rkps_ozn_' + rkps_number) ? document.getElementById('rkps_ozn_' + rkps_number).innerHTML = value : "";
                                }
                            }
                            // ... ОСНОВНАЯ ЗОНА НАРУШЕНА

                            // ДОПОЛНИТЕЛЬНАЯ ЗОНА НАРУШЕНА ...    
                            value = '';
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                for (var k = 0; k < virtualZone.length; k++) {
                                    if (data.result.config[i].key.slice(4) == virtualZone[k].link.slice(4) && '2' == virtualZone[k].index) {
                                        if (virtualZone[k].type == '1' && virtualZone[k].param == '0' && virtualZone[k].delay == '0') {
                                            value = 'Исключена'
                                        }
                                    }
                                }

                                if (value !== 'Исключена') {
                                    value = data.result.config[i].subvalues[5].value;
                                    if (value & 0x400) {
                                        value = '<span style="color:red">Нарушена<span>';
                                    } else {
                                        value = '<span style="color:green">В норме</span>';
                                    }
                                    document.getElementById('rkps_dzn_' + rkps_number) ? document.getElementById('rkps_dzn_' + rkps_number).innerHTML = value : "";
                                } else {
                                    document.getElementById('rkps_dzn_' + rkps_number) ? document.getElementById('rkps_dzn_' + rkps_number).innerHTML = value : "";
                                }

                            }
                            // ... ДОПОЛНИТЕЛЬНАЯ ЗОНА НАРУШЕНА

                            // САБОТАЖ ОСНОВНОЙ ЗОНЫ ...                
                            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            if (rkps_dom) {
                                value = data.result.config[i].subvalues[5].value;
                                if (value & 0x800) {
                                    value = '<span style="color:red">Саботаж</span>';
                                } else {
                                    value = '';
                                }
                                document.getElementById('rkps_sabotag_' + rkps_number) ? document.getElementById('rkps_sabotag_' + rkps_number).innerHTML = value : "";
                            }
                            // ... САБОТАЖ ОСНОВНОЙ ЗОНЫ

                            // РП резервное питание ...                
                            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
                            // if (rkps_dom) {
                            //     value = data.result.config[i].subvalues[5].value;
                            //     if (value & 0x1000) {
                            //         value = 'Резерв.';
                            //     } else {
                            //         value = 'Осн.';
                            //     }
                            //     document.getElementById('rkps_rezervpower_' + rkps_number) ? document.getElementById('rkps_rezervpower_' + rkps_number).innerHTML = value : "";
                            // }
                            //... РП резервное питание

                        } else {
                            let rkps_number = data.result.config[i].key.slice(4); // НОМЕР РК ДАТЧИКА
                            document.getElementById('rkps_program_' + rkps_number) ? document.getElementById('rkps_program_' + rkps_number).innerHTML = '<span style="color:red">Нет</span>' : '';
                        }
                    } // До сюда

                }
            }
        }
    }
    xhr.send();
}

