function zone_create_list(data) {
    let nameDevice = data.subvalues[1].value;
    let numberDevice = data.key.substring(4); // номер устройства
    let firstZone, secondZone;

    let number_1_Cannel = "xxdr" + numberDevice + "_0"; //Название первой зоны
    let number_2_Cannel = "xxdr" + numberDevice + "_1"; // название второй зоны
    let LW_YZ_1 = dataDevice[number_1_Cannel].value; // номер ключа LW и YZ для основного
    let LW_YZ_2 = dataDevice[number_2_Cannel].value; // номер ключа LW и YZ для дополительного

    let configLW_1 = {};
    let configYZ_1 = {};

    let configLW_2 = {};
    let configYZ_2 = {};

    if (LW_YZ_1 != "") {
        let nameYZ1 = "yz" + LW_YZ_1;
        let nameLW1 = "lw" + LW_YZ_1;
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key == nameYZ1) {
                configYZ_1 = deviceJSON.config[i];
            }
            if (deviceJSON.config[i].key == nameLW1) {
                configLW_1 = deviceJSON.config[i];
            }
        }
    }

    if (LW_YZ_2 != "") {
        let nameYZ2 = "yz" + LW_YZ_2;
        let nameLW2 = "lw" + LW_YZ_2;

        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key == nameYZ2) {
                configYZ_2 = deviceJSON.config[i];
            }
            if (deviceJSON.config[i].key == nameLW2) {
                configLW_2 = deviceJSON.config[i];
            }
        }
    }


    if (LW_YZ_2 !== 0 && LW_YZ_1 !== 0 && LW_YZ_2 !== "" && LW_YZ_1 !== "") {
        switch (nameDevice) {
            case "15231":
                firstZone = numberDevice + "_0";
                list_zone[firstZone] = {
                    numberDevice: numberDevice,
                    nameDevice: nameDevice,
                    thisSecond: false,
                    thisDom: false,
                    type: "guard_radio",
                    lw: configLW_1,
                    section: configYZ_1,
                    numberZone: configLW_1.key.slice(2)
                };

                break;
            case "15230":
                firstZone = numberDevice + "_0";
                list_zone[firstZone] = {
                    numberDevice: numberDevice,
                    nameDevice: nameDevice,
                    thisSecond: false,
                    thisDom: false,
                    type: "guard_radio",
                    lw: configLW_1,
                    section: configYZ_1,
                    numberZone: configLW_1.key.slice(2)
                };
                break;

            case "15130":
                firstZone = numberDevice + "_0";
                secondZone = numberDevice + "_1";
                list_zone[firstZone] = {
                    numberDevice: numberDevice,
                    nameDevice: nameDevice,
                    thisSecond: false,
                    thisDom: false,
                    type: "guard_radio",
                    lw: configLW_1,
                    section: configYZ_1,
                    numberZone: configLW_1.key.slice(2)
                };
                list_zone[secondZone] = {
                    numberDevice: numberDevice,
                    nameDevice: nameDevice,
                    thisSecond: true,
                    thisDom: false,
                    type: "guard_radio",
                    lw: configLW_2,
                    section: configYZ_2,
                    numberZone: configLW_2.key.slice(2)
                };

                break;
            case "15830":
                firstZone = numberDevice + "_0";
                list_zone[firstZone] = {
                    numberDevice: numberDevice,
                    nameDevice: nameDevice,
                    thisSecond: false,
                    thisDom: false,
                    type: "guard_radio",
                    lw: configLW_1,
                    section: configYZ_1,
                    numberZone: configLW_1.key.slice(2)
                };
                break;

            case "16270":
                // клавиатура
                break;
            case "16370":
                // брелок
                break;

            default:
                console.log("я таких устройст не знаю");
        }
    }

}

function section_list_new(data) {
    // Генерация интерфейса при клике по кнопке
    let maxNumberSec = 0;
    for (var i = 0; i < virtualSection.length; i++) {
        if (+virtualSection[i].number >= maxNumberSec) {
            maxNumberSec = +virtualSection[i].number;
        }
    }

    if (maxNumberSec < +DEVICEINFO[DEVICEMODEL].sections) {
        ++maxNumberSec;
        virtualSection.push({ "number": maxNumberSec, "zone": [] });

        let div = document.createElement("div");
        div.innerHTML = "<b style='color:#2196f3; font-size:26px;'>Раздел №" + maxNumberSec + "</b>";
        div.innerHTML += '<div style="float:right; padding-bottom:10px"><label style="float:left"><button class=" w3-btn w3-blue w3-border w3-border-blue" onclick="open_modal_Rdevice(\'-1\',' + maxNumberSec + ')">+ Добавить устройство</button></label></div>';
        div.classList.add("w3-code", "w3-border-blue");
        document.getElementById("tab_section_list").appendChild(div);
    } else {
        document.getElementById('btn_section_list_new').innerHTML = '<span>Превышен лимит разделов</span>';
    }

    //scroll down page
    var scrollingElement = (document.scrollingElement || document.body);
    scrollingElement.scrollTop = scrollingElement.scrollHeight;
}

function compareZone(zoneA, zoneB) {
    return +zoneA.numberZone - +zoneB.numberZone;
}



function open_modal_thisDevice(numberZoneEdit) {
    // Редакор встроенной зоны
    CACHE_EDIT_INTEGRATION_ZONE = numberZoneEdit;
    document.getElementById('modal_r_device_title').innerHTML = 'Настройка встроенной зоны устройства';
    let modelDevice = '15130';
    CACHE_EDIT_R_DEVICE = {
        "id": 'thisDevice', // ИД редактируемого датчика
        "section": numberZoneEdit //Номер раздела откуда вызвали карточку
    };
    let str = '';

    str += "<div class='w3-card' style='margin:15px 10px 15px 4px; padding:5px;' id='modal_r_device_zone'>";
    str += '<div id="open_modal_Rdevice_confZone">'
    for (var i = 0; i < virtualZone.length; i++) {
        if (virtualZone[i].numberZone == numberZoneEdit) {
            str += '<table class="w3-table w3-table-all"><tbody>';
            str += '<tr>';
            str += '<td>№ Зоны</td>';
            str += '<td>Тип</td>';
            str += '<td>Задержка</td>';
            str += '<td>Раздел</td>';
            str += '</tr>';
            // Основная зона устрйоства 
            str += '<tr>';
            str += "<td><input ";
            if (modelDevice == "-1") {
                str += "  "; // здесь можно поставить disable
            }
            str += " onchange='' type='number' id='adresZone_1' style='width:60px' value='";
            if (numberZoneEdit == undefined) {
                str += pickUpYzLw("lw", "2")[0];
                // генерируем новые свободные адреса
            } else {
                str += numberZoneEdit;
                // тянем адреса из конфига 
            }

            str += "'></td>";
            str += '<td>' + selectedTypeGuardZone(modelDevice, virtualZone[i].type, virtualZone[i].param, 1, virtualZone[i].delay, 'modal', '1') + '</td>';
            str += "<td><input";
            let disablDelay = delaySection_DISABLED(virtualZone[i].type, virtualZone[i].param);
            let valueDelay = '';
            if (disablDelay.yes) {
                if (virtualZone[i].delay == 0 || virtualZone[i].delay == '' || virtualZone[i].delay == undefined) {
                    str += ' disabled ';
                    valueDelay = '';
                } else {
                    valueDelay = virtualZone[i].delay;
                }
            } else {
                valueDelay = virtualZone[i].delay;
            }
            str += " style='width:60px' id='modal_r_device_zone_delay_1' value='";
            str += valueDelay;
            str += "' type='number'></td>";
            str += '<td>';
            str += "<select id='nomberZone_Section_1'>";
            // str += "<label><option>";
            // str += "Не выбран";
            // str += "</option></label>";

            for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
                str += "<label>";
                str += "<option ";

                // Проверка на клик из блока раздела на добавление устройства
                if (+virtualZone[i].section == r) {
                    str += ' selected ';
                }

                str += " value='" + r + "' name='" + r + "'  ";
                str += " > Раздел " + r + "</option></label>";
            }
            str += "</select>";
            str += '</td>';
            str += '</tr>'

            str += '</tbody></table>';
            break;
        }
    }
    str += "</div>"; // Настройки зон
    str += "</div>"; // Настройки зон
    str += "<div class='w3-card w3-animate-top w3-red' style='margin:15px 10px 15px 4px; padding:5px; cursor:context-menu; color:red; display:none' id='modal_r_device_error'></div>"; // Описание
    //str += "<div class='w3-card' style='margin:15px 10px 15px 4px; padding:5px; cursor:context-menu;' id='modal_r_device_description'></div>"; // Описание
    //str += "<div class='w3-card w3-animate-top w3-red' style='margin:15px 10px 15px 4px; padding:5px; cursor:context-menu; color:red; display:none' id='modal_r_device_error'></div>"; // Описание
    document.getElementById("modal_r_device_body").innerHTML = str;
    document.getElementById("modal_r_device").style.display = "block";
}

let CACHE_EDIT_R_DEVICE = {
    "id": null, // ID Радио датчика
    "numberSection": null
};

function open_modal_Rdevice(id, section) {
    if (id == '-1') {
        if (!ckeckChannelTransmitter('new')) {
            open_modal_RdeviceRun(id, section)
        }
    } else {
        open_modal_RdeviceRun(id, section);
    }

}

function searchSerialNumber(id) {
    for (i in rkps_device) {
        if (rkps_device[i].numberRadio == id) {
            if (rkps_device[i].serial !== undefined){
                return rkps_device[i].serial
            } else {
                return ''
            }
             
        }
    }
}

function open_modal_RdeviceRun(id, section) {
    CACHE_EDIT_R_DEVICE = {
        "id": id, // ИД редактируемого датчика
        "section": section, //Номер раздела откуда вызвали карточку
        "serial": searchSerialNumber(id)
    };
    let str = "<table>";
    let serialNumber = searchSerialNumber(id) ? searchSerialNumber(id) : '';
    str +=
        "<tr>" +
        "<td style='width:300px'><b>Тип устройства</b></br>" +
        modal_name_Rdevice(section) +
        "</td><td><b>Серийный номер</b><br><input disabled value='" + serialNumber + "'></td><td style='width:10px'></td><td style='width:60px'><div style='display:none'>Адрес </br><input disabled style='width:100%'></div><td style='width:10px'></td></tr>";
    str += "</table>";

    str += "<div class='w3-card' style='margin:15px 10px 15px 4px; padding:5px;' id='modal_r_device_zone'>";
    str += '<div id="open_modal_Rdevice_confZone">'
    str += "</div>"; // Настройки зон
    str += "</div>"; // Настройки зон
    str += "<div class='w3-card' style='margin:15px 10px 15px 4px; padding:5px; cursor:context-menu;' id='modal_r_device_description'></div>"; // Описание
    str += "<div class='w3-card w3-animate-top w3-red' style='margin:15px 10px 15px 4px; padding:5px; cursor:context-menu; color:red; display:none' id='modal_r_device_error'></div>"; // Описание
    document.getElementById("modal_r_device_body").innerHTML = str;
    document.getElementById("modal_r_device").style.display = "block";

    if (id == "-1") {
        // Добавление нового устроства
        document.getElementById("modal_r_device_title").innerText = "Добавление нового устройства";
        $.hide("#modal_r_device_delete"); // кнопка удаления
        document.getElementById('modal_r_device_name').disabled = false; //Блокировка смены модели
        set_r_device_name('0', null, null, section); // стартуем по дефолту
    } else {
        $.show("#modal_r_device_delete"); // кнопка удаления
        document.getElementById('modal_r_device_name').disabled = true; //Блокировка смены модели
        document.getElementById("modal_r_device_title").innerText = "Настройка устройства №" + id;
        for (var i = 0; i < virtualRadio.length; i++) {
            if (virtualRadio[i].numberRadio == id) {
                document.getElementById('modal_r_device_name').value = virtualRadio[i].name; // Задаем тип устройства
                set_r_device_name(virtualRadio[i].name, virtualRadio[i].zone_1, virtualRadio[i].zone_2, section); // стартуем с моделькой 
                break;
            }
        }
    }
}

function open_modal_Rdevice_configZone(data) {

}


function set_r_device_name(modelDevice, zone_1, zone_2, sections) {
    // переключатель названия устройства
    //modelDevice модель устройства
    // в sections номер раздела

    if (+modelDevice === 0) {
        $.hide('#modal_r_device_zone');
        $.hide('#modal_r_device_description');
    } else {
        $.show('#modal_r_device_zone');
        $.show('#modal_r_device_description');
    }
    $.hide("#modal_r_device_error"); // Скрыть блок ошибок
    let summZone = R_DEVICE_NAME[modelDevice].zone; // количество зон устройства
    let str = '';
    let paramZone_1 = {};
    if (zone_1 !== null) {
        for (var z = 0; z < virtualZone.length; z++) {
            if (virtualZone[z].numberZone === zone_1) {
                paramZone_1 = virtualZone[z];
            }
        }
    }
    let paramZone_2 = {};
    if (zone_2 !== null) {
        for (var z = 0; z < virtualZone.length; z++) {
            if (virtualZone[z].numberZone === zone_2) {
                paramZone_2 = virtualZone[z];
            }
        }
    }

    if (modelDevice === "15130") {
        str += "<b>Настройка зон устройства:</b>";
        str += '<table class="w3-table w3-table-all"><tbody>';
        str += '<tr>';
        str += '<td>№ Зоны</td>';
        str += '<td></td>';
        str += '<td>Тип</td>';
        str += '<td>Задержка</td>';
        str += '<td>Раздел</td>';
        str += '</tr>';
        // Основная зона устрйоства 
        str += '<tr>';
        str += "<td><input ";
        if (modelDevice == "-1") {
            str += "  "; // здесь можно поставить disable
        }
        str += " onchange='' type='number' id='adresZone_1' style='width:60px' value='";

        if (zone_1 == undefined) {
            str += pickUpYzLw("lw", "2")[0];
            // генерируем новые свободные адреса
        } else {
            str += zone_1;
            // тянем адреса из конфига 
        }

        str += "'></td>";
        str += '<td>Основная</td>';
        str += '<td>' + selectedTypeGuardZone(modelDevice, paramZone_1.type, paramZone_1.param, 1, paramZone_1.delay, 'modal', '1') + '</td>';
        str += "<td><input";
        let disablDelay = delaySection_DISABLED(paramZone_1.type, paramZone_1.param);
        let valueDelay = '';
        if (disablDelay.yes) {
            if (paramZone_1.delay == 0 || paramZone_1.delay == '' || paramZone_1.delay == undefined) {
                str += ' disabled ';
                valueDelay = '';
            } else {
                valueDelay = paramZone_1.delay;
            }
        } else {
            valueDelay = paramZone_1.delay;
        }
        str += " style='width:60px' id='modal_r_device_zone_delay_1' value='";
        str += valueDelay;
        str += "' type='number'></td>";
        str += '<td>';
        str += "<select id='nomberZone_Section_1'>";
        // str += "<label><option>";
        // str += "Не выбран";
        // str += "</option></label>";

        for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
            str += "<label>";
            str += "<option ";
            if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_1.section !== r) {
                // Проверка на клик из блока раздела на добавление устройства
                if (+CACHE_EDIT_R_DEVICE.section == r) {
                    str += ' selected ';
                }
            } else if (+paramZone_1.section == r) {
                str += ' selected ';
            } else { }
            str += " value='" + r + "' name='" + r + "'  ";
            str += " > Раздел " + r + "</option></label>";
        }
        str += "</select>";
        str += '</td>';
        str += '</tr>'
        // Дополнительная зона устрйоства 
        str += '<tr>';
        str += "<td><input ";
        if (modelDevice == "-1") {
            str += "  "; // здесь можно поставить disable
        }
        str += " onchange='' type='number' id='adresZone_2' style='width:60px' value='";

        if (zone_2 == undefined) {
            str += pickUpYzLw("lw", "2")[1];
            // генерируем новые свободные адреса
        } else {
            str += zone_2;
            // тянем адреса из конфига 
        }

        str += "'></td>";
        str += '<td>Доп.</td>';
        str += '<td>' + selectedTypeGuardZone(modelDevice, paramZone_2.type, paramZone_2.param, 2, paramZone_2.delay, 'modal', '2') + '</td>';
        str += "<td><input";

        let disablDelay2 = delaySection_DISABLED(paramZone_2.type, paramZone_2.param);
        let valueDelay2 = '';
        if (disablDelay2.yes) {
            if (paramZone_2.delay == 0 || paramZone_2.delay == '' || paramZone_2.delay == undefined) {
                str += ' disabled ';
                valueDelay2 = '';
            } else {
                valueDelay2 = paramZone_2.delay;
            }
        } else {
            valueDelay2 = paramZone_2.delay;
        }

        str += " style='width:60px' id='modal_r_device_zone_delay_2' value='";
        str += valueDelay2;
        str += "' type='number'></td>";
        str += '<td>';
        str += "<select id='nomberZone_Section_2'>";
        // str += "<label><option>";
        // str += "Не выбран";
        // str += "</option></label>";

        for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
            str += "<label>";
            str += "<option ";

            if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_2.section !== r) {
                // Проверка на клик из блока раздела на добавление устройства
                if (+CACHE_EDIT_R_DEVICE.section == r) {
                    str += ' selected ';
                }
            } else if (+paramZone_2.section == r) {
                str += ' selected ';
            } else { }

            str += " value='" + r + "' name='" + r + "'  ";
            str += " > Раздел " + r + "</option></label>";
        }
        str += "</select>";
        str += '</td>';
        str += '</tr>'

        str += '</tbody></table>';

        // настройки сенсоров
        str += '</br><b>Настройка датчика:</b>';
        str += '<table><tr><td><label><input ';
        for (j in virtualRadio) {
            if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
                if (virtualRadio[j].SS & 1) {
                    str += ' checked ';
                }
            }
        }
        str += ' id="sensor_sabotaje" type="checkbox" class="w3-check"> Датчик саботажа </label></td>';
        //str += '<td><label><input type="checkbox" class="w3-check"> Индикация</label></td>';
        str += '</tr></table>';

    } else if (modelDevice === '15230') {
        str += "<b>Настройка зон устройства:</b>";
        str += '<table class="w3-table w3-table-all"><tbody>';
        str += '<tr>';
        str += '<td>№ Зоны</td>';
        str += '<td>Тип</td>';
        str += '<td>Задержка</td>';

        str += '<td>Раздел</td>';
        str += '</tr>';
        // Основная зона устрйоства 
        str += '<tr>';
        str += "<td><input ";
        if (modelDevice == "-1") {
            str += "  "; // здесь можно поставить disable
        }
        str += " onchange='' type='number' id='adresZone_1' style='width:60px' value='";
        if (zone_1 == undefined) {
            str += pickUpYzLw("lw", "2")[0];
            // генерируем новые свободные адреса
        } else {
            str += zone_1;
            // тянем адреса из конфига 
        }

        str += "'></td>";
        str += '<td>' + selectedTypeGuardZone(modelDevice, paramZone_1.type, paramZone_1.param, 1, paramZone_1.delay, 'modal', '1') + '</td>';
        str += "<td><input";
        let disablDelay = delaySection_DISABLED(paramZone_1.type, paramZone_1.param);
        let valueDelay = '';
        if (disablDelay.yes) {
            if (paramZone_1.delay == 0 || paramZone_1.delay == '' || paramZone_1.delay == undefined) {
                str += ' disabled ';
                valueDelay = '';
            } else {
                valueDelay = paramZone_1.delay;
            }
        } else {
            valueDelay = paramZone_1.delay;
        }
        str += " style='width:60px' id='modal_r_device_zone_delay_1' value='";
        str += valueDelay;
        str += "' type='number'></td>";

        str += '<td>';
        str += "<select id='nomberZone_Section_1'>";
        // str += "<label><option>";
        // str += "Не выбран";
        // str += "</option></label>";

        for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
            str += "<label>";
            str += "<option ";
            if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_1.section !== r) {
                // Проверка на клик из блока раздела на добавление устройства
                if (+CACHE_EDIT_R_DEVICE.section == r) {
                    str += ' selected ';
                }
            } else if (+paramZone_1.section == r) {
                str += ' selected ';
            } else { }
            str += " value='" + r + "' name='" + r + "'  ";
            str += " > Раздел " + r + "</option></label>";
        }
        str += "</select>";
        str += '</td>';

        str += '</tr>'
        str += '</tbody></table>';

        str += '</br><b>Настройка датчика:</b>';
        str += '<table><tr><td><label><input';
        for (j in virtualRadio) {
            if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
                if (virtualRadio[j].SS & 1) {
                    str += ' checked ';
                }
            }
        }
        str += ' type="checkbox" id="dal_bol_10_5230" class="w3-check"> Дальность менее 10 метров </label></td>';
        str += '</tr></table>';

    } else if (modelDevice === '15231') {
        str += "<b>Настройка зон устройства:</b>";
        str += '<table class="w3-table w3-table-all"><tbody>';
        str += '<tr>';
        str += '<td>№ Зоны</td>';
        str += '<td>Тип</td>';
        str += '<td>Задержка</td>';
        str += '<td>Раздел</td>';
        str += '</tr>';
        // Основная зона устрйоства 
        str += '<tr>';
        str += "<td><input ";
        if (modelDevice == "-1") {
            str += "  "; // здесь можно поставить disable
        }
        str += " onchange='' type='number' id='adresZone_1' style='width:60px' value='";
        if (zone_1 == undefined) {
            str += pickUpYzLw("lw", "2")[0];
            // генерируем новые свободные адреса
        } else {
            str += zone_1;
            // тянем адреса из конфига 
        }

        str += "'></td>";
        str += '<td>' + selectedTypeGuardZone(modelDevice, paramZone_1.type, paramZone_1.param, 1, paramZone_1.delay, 'modal', '1') + '</td>';
        str += "<td><input";
        let disablDelay = delaySection_DISABLED(paramZone_1.type, paramZone_1.param);
        let valueDelay = '';
        if (disablDelay.yes) {
            if (paramZone_1.delay == 0 || paramZone_1.delay == '' || paramZone_1.delay == undefined) {
                str += ' disabled ';
                valueDelay = '';
            } else {
                valueDelay = paramZone_1.delay;
            }
        } else {
            valueDelay = paramZone_1.delay;
        }
        str += " style='width:60px' id='modal_r_device_zone_delay_1' value='";
        str += valueDelay;
        str += "' type='number'></td>";
        str += '<td>';
        str += "<select id='nomberZone_Section_1'>";
        // str += "<label><option>";
        // str += "Не выбран";
        // str += "</option></label>";

        for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
            str += "<label>";
            str += "<option ";
            if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_1.section !== r) {
                // Проверка на клик из блока раздела на добавление устройства
                if (+CACHE_EDIT_R_DEVICE.section == r) {
                    str += ' selected ';
                }
            } else if (+paramZone_1.section == r) {
                str += ' selected ';
            } else { }
            str += " value='" + r + "' name='" + r + "'  ";
            str += " > Раздел " + r + "</option></label>";
        }
        str += "</select>";
        str += '</td>';
        str += '</tr>'

        str += '</tbody></table>';

        str += '</br><b>Настройка датчика:</b>';
        str += '<table><tr><td><label><input';
        for (j in virtualRadio) {
            if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
                if (virtualRadio[j].SS & 1) {
                    str += ' checked ';
                }
            }
        }
        str += ' id="zveri_on" type="checkbox" class="w3-check"> Устойчивость к животным </label></td>';
        str += '</tr></table>';

    } else if (modelDevice === '15830') {
        str += "<b>Настройка зон устройства:</b>";
        str += '<table class="w3-table w3-table-all"><tbody>';
        str += '<tr>';
        str += '<td>№ Зоны</td>';

        str += '<td></td>';
        str += '<td>Тип</td>';
        str += '<td>Задержка</td>';
        str += '<td>Раздел</td>';
        str += '</tr>';
        // Основная зона устрйоства 
        str += '<tr>';


        str += "<td><input ";
        if (modelDevice == "-1") {
            str += "  "; // здесь можно поставить disable
        }
        str += " onchange='' type='number' id='adresZone_1' style='width:60px' value='";
        if (zone_1 == undefined) {
            str += pickUpYzLw("lw", "2")[0];
            // генерируем новые свободные адреса
        } else {
            str += zone_1;
            // тянем адреса из конфига 
        }

        str += "'></td>";
        str += "<td>Основная</td>";
        str += '<td>' + selectedTypeGuardZone(modelDevice, paramZone_1.type, paramZone_1.param, 1, paramZone_1.delay, 'modal', '1') + '</td>';
        str += "<td><input";
        let disablDelay = delaySection_DISABLED(paramZone_1.type, paramZone_1.param);
        let valueDelay = '';
        if (disablDelay.yes) {
            if (paramZone_1.delay == 0 || paramZone_1.delay == '' || paramZone_1.delay == undefined) {
                str += ' disabled ';
                valueDelay = '';
            } else {
                valueDelay = paramZone_1.delay;
            }
        } else {
            valueDelay = paramZone_1.delay;
        }
        str += " style='width:60px' id='modal_r_device_zone_delay_1' value='";
        str += valueDelay;
        str += "' type='number'></td>";

        str += '<td>';
        str += "<select id='nomberZone_Section_1'>";
        // str += "<label><option>";
        // str += "Не выбран";
        // str += "</option></label>";

        for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
            str += "<label>";
            str += "<option ";
            if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_1.section !== r) {
                // Проверка на клик из блока раздела на добавление устройства
                if (+CACHE_EDIT_R_DEVICE.section == r) {
                    str += ' selected ';
                }
            } else if (+paramZone_1.section == r) {
                str += ' selected ';
            } else { }
            str += " value='" + r + "' name='" + r + "'  ";
            str += " > Раздел " + r + "</option></label>";
        }
        str += "</select>";
        str += '</td>';
        str += '</tr>'
        // Дополнительная зона
        str += '<tr>';
        str += "<td><input ";
        if (modelDevice == "-1") {
            str += "  "; // здесь можно поставить disable
        }
        str += " onchange='' type='number' id='adresZone_2' style='width:60px' value='";

        if (zone_2 == undefined) {
            str += pickUpYzLw("lw", "2")[1];
            // генерируем новые свободные адреса
        } else {
            str += zone_2;
            // тянем адреса из конфига 
        }

        str += "'></td>";
        str += '<td>Доп.</td>';
        str += '<td>' + selectedTypeGuardZone(modelDevice, paramZone_2.type, paramZone_2.param, 2, paramZone_2.delay, 'modal', '2') + '</td>';

        str += "<td><input";
        let disablDelay2 = delaySection_DISABLED(paramZone_2.type, paramZone_2.param);
        let valueDelay2 = '';
        if (disablDelay2.yes) {
            if (paramZone_2.delay == 0 || paramZone_2.delay == '' || paramZone_2.delay == undefined) {
                str += ' disabled ';
                valueDelay2 = '';
            } else {
                valueDelay2 = paramZone_2.delay;
            }
        } else {
            valueDelay2 = paramZone_2.delay;
        }
        str += " style='width:60px' id='modal_r_device_zone_delay_2' value='";
        str += valueDelay2;
        str += "' type='number'></td>";

        str += '<td>';
        str += "<select id='nomberZone_Section_2'>";
        // str += "<label><option>";
        // str += "Не выбран";
        // str += "</option></label>";

        for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
            str += "<label>";
            str += "<option ";

            if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_2.section !== r) {
                // Проверка на клик из блока раздела на добавление устройства
                if (+CACHE_EDIT_R_DEVICE.section == r) {
                    str += ' selected ';
                }
            } else if (+paramZone_2.section == r) {
                str += ' selected ';
            } else { }

            str += " value='" + r + "' name='" + r + "'  ";
            str += " > Раздел " + r + "</option></label>";
        }
        str += "</select>";
        str += '</td>';
        str += '</tr>'

        str += '</tbody></table>';

        str += '</br><b>Настройка датчика:</b>';
        str += '<table><tr><td><label><input ';
        for (j in virtualRadio) {
            if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
                if (virtualRadio[j].SS & 1) {
                    str += ' checked ';
                }
            }
        }
        str += ' id="dist_4_m" type="checkbox" class="w3-check"> Дистанция менее 4 метров </label></td>';
        str += '<td><label><input ';
        for (j in virtualRadio) {
            if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
                if (virtualRadio[j].SS & 2) {
                    str += ' checked ';
                }
            }
        }
        str += ' type="checkbox" id="glass_2" class="w3-check"> Стекло размером менее 0,2 м<sup><small>2</small></sup></label></td>';
        str += '<td><label><input ';
        for (j in virtualRadio) {
            if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
                if (virtualRadio[j].SS & 4) {
                    str += ' checked ';
                }
            }
        }
        str += ' type="checkbox" id="glass_crash" class="w3-check"> Выпадение осколков</label></td>';
        str += '</tr></table>';


    } else if (modelDevice === '16270') {

    } else if (modelDevice === '16370') {
        let TRINKED_CONFIG = [];
        let nameKey = 'xxnb' + CACHE_EDIT_R_DEVICE.id + '_1'; //Название ключа xxnb
        if (CACHE_EDIT_R_DEVICE.id === '-1') {
            // ПРИ ДОБАВЛЕНИИ НОВОГО БРЕЛКА
            TRINKED_CONFIG.push('0,0,0,0');
            TRINKED_CONFIG.push('0,0,0,0');
            TRINKED_CONFIG.push('0,0,0,0');
            TRINKED_CONFIG.push('0,0,0,0');
        } else {
            // ПРИ ОТКРЫТИИ РАДИОБРЕЛКА
            TRINKED_CONFIG = dataDevice[nameKey].value.split(';');
        }

        str += "<b>Настройка кнопок устройства:</b>";
        str += '<table class="w3-table w3-table-all"><thead>';
        str += '</thead>';

        str += '<tbody>';
        str += '<tr>';
        str += '<td><img class="img_brelok" src="images/6370/6370_1.png"></img></td>';
        str += '<td style="border-right:1px solid #a2a2a2">' + trinketFunction_list(0, TRINKED_CONFIG[0]) + '</td>';
        str += '<td><img class="img_brelok" src="images/6370/6370_2.png"></img></td>';
        str += '<td>' + trinketFunction_list(1, TRINKED_CONFIG[1]) + '</td>';
        str += '</tr>';
        str += '<td><img class="img_brelok" src="images/6370/6370_3.png"></img></td>';
        str += '<td style="border-right:1px solid #a2a2a2">' + trinketFunction_list(2, TRINKED_CONFIG[2]) + '</td>';
        str += '<td><img class="img_brelok" src="images/6370/6370_4.png"></img></td>';
        str += '<td>' + trinketFunction_list(3, TRINKED_CONFIG[3]) + '</td>';
        str += '</tr>';
        str += '</tbody>';
        str += '</table>';

    } else {
        str += 'Предназначено для обеспечения электропитания исполнительных механизмов (нагрузки).';
    }

    document.getElementById('open_modal_Rdevice_confZone').innerHTML = str; // всталяем настройки зон устройства 

    let description = R_DEVICE_NAME[modelDevice].description; // Достаем описание устройства 
    document.getElementById("modal_r_device_description").innerHTML = description; // вставлем описание устройства
    // if (R_DEVICE_NAME[data.value].zone == "0") {
    //   $.hide("#modal_r_device_zone");
    //   $.hide("#modal_r_device_zone_1");
    //   $.hide("#modal_r_device_zone_2");
    // } else if (R_DEVICE_NAME[data.value].zone == "1") {
    //   $.show("#modal_r_device_zone");
    //   $.show("#modal_r_device_zone_1");
    //   $.hide("#modal_r_device_zone_2");
    // } else if (R_DEVICE_NAME[data.value].zone == "2") {
    //   $.show("#modal_r_device_zone_1");
    //   $.show("#modal_r_device_zone_2");
    //   $.show("#modal_r_device_zone");
    // }
}

function trinketFunction_list(button, TRINKED_CONFIG) {
    let configArr = TRINKED_CONFIG.split(',');
    let value = { "click": +configArr[0], "clickUsr": +configArr[1], "longClick": +configArr[2], "longUsr": +configArr[3] };

    // НАЖАТИЕ . . .
    let str = '<label>Нажатие <select class="trinket_func_select" id="trinket_fn_clck_' + button + '">';
    str += '<option';
    if (value.click === 0) {
        str += ' selected ';
    }
    str += ' value="0">Не назначена</option>'
    str += '<option';
    if (value.click === 1) {
        str += ' selected ';
    }
    str += ' value="1">Взять под охрану</option>'
    str += '<option';
    if (value.click === 2) {
        str += ' selected ';
    }
    str += ' value="2"';
    if (value.click === 3) {
        str += ' selected ';
    }
    str += '>Снять с охраны</option>'
    str += '<option';
    if (value.click === 3) {
        str += ' selected ';
    }
    str += 'value="3">Взятие под принуждением</option>'
    str += '<option';
    if (value.click === 4) {
        str += ' selected ';
    }
    str += ' value="4">Снятие под принуждением</option>'
    str += '<option';
    if (value.click === 5) {
        str += ' selected ';
    }
    str += ' value="5">Активировать исполнительное устройство</option>'
    str += '<option';
    if (value.click === 6) {
        str += ' selected ';
    }
    str += ' value="6">Деактивировать исполнительное устройство</option>'
    str += '<option';
    if (value.click === 7) {
        str += ' selected ';
    }
    str += ' value="7">Изменить состояние исполнительного устройства</option>'
    str += '<option';
    if (value.click === 8) {
        str += ' selected ';
    }
    str += ' value="8">Патруль</option>'
    str += '<option';
    if (value.click === 9) {
        str += ' selected ';
    }
    str += ' value="9">КТС</option>'
    str += '</select></label>';
    // ...НАЖАТИЕ

    // Пользователь НАЖАТИЯ ...
    str += '</br><label>Номер кода<select class="trinket_func_select" id="trinket_clc_usr_' + button + '"><option value="0">Не выбран</option>';
    for (i in key_UA_UZ) {
        str += '<option ';
        if (value.clickUsr === +key_UA_UZ[i].number) {
            str += ' selected ';
        }
        str += ' value="' + key_UA_UZ[i].number + '">'
        str += key_UA_UZ[i].number
        str += '</option>'
    }
    str += '</select></label>';
    // ... Пользователь НАЖАТИЯ

    // ДЛИННОЕ НАЖАТИЕ . . .
    str += '<hr><label>Долгое нажатие <select style="width:150px" class="trinket_func_select" id="trinket_fn_long_clck_' + button + '">';
    str += '<option';
    if (value.longClick === 0) {
        str += ' selected ';
    }
    str += ' value="0">Не назначена</option>'
    str += '<option';
    if (value.longClick === 1) {
        str += ' selected ';
    }
    str += ' value="1">Взять под охрану</option>'
    str += '<option';
    if (value.longClick === 2) {
        str += ' selected ';
    }
    str += ' value="2"';
    if (value.longClick === 3) {
        str += ' selected ';
    }
    str += '>Снять с охраны</option>'
    str += '<option';
    if (value.longClick === 3) {
        str += ' selected ';
    }
    str += 'value="3">Взятие под принуждением</option>'
    str += '<option';
    if (value.longClick === 4) {
        str += ' selected ';
    }
    str += ' value="4">Снятие под принуждением</option>'
    str += '<option';
    if (value.longClick === 5) {
        str += ' selected ';
    }
    str += ' value="5">Активировать исполнительное устройство</option>'
    str += '<option';
    if (value.longClick === 6) {
        str += ' selected ';
    }
    str += ' value="6">Деактивировать исполнительное устройство</option>'
    str += '<option';
    if (value.longClick === 7) {
        str += ' selected ';
    }
    str += ' value="7">Изменить состояние исполнительного устройства</option>'
    str += '<option';
    if (value.longClick === 8) {
        str += ' selected ';
    }
    str += ' value="8">Патруль</option>'
    str += '<option';
    if (value.longClick === 9) {
        str += ' selected ';
    }
    str += ' value="9">КТС</option>'
    str += '</select></label>';
    //  . . . ДЛИННОЕ НАЖАТИЕ
    // Пользователь НАЖАТИЯ ...
    str += '</br><label>Номер кода<select class="trinket_func_select" id="trinket_long_usr_' + button + '"><option value="0">Не выбран</option>';
    for (i in key_UA_UZ) {
        str += '<option ';
        if (value.longUsr === +key_UA_UZ[i].number) {
            str += ' selected ';
        }
        str += ' value="' + key_UA_UZ[i].number + '">'
        str += key_UA_UZ[i].number
        str += '</option>'
    }
    str += '</select></label>';
    // ... Пользователь НАЖАТИЯ
    return str
}

function modal_name_Rdevice(data) {
    let str = "";
    str += "<select id='modal_r_device_name' style='height:33px; width:100%;' onchange='set_r_device_name(this.value,undefined,undefined,undefined)'>";
    for (i in R_DEVICE_NAME) {
        if (data === null) {
            str += '<option value="' + i + '" ';
            if (data == i) {
                str += " selected ";
            }
            str += " >";
            str += R_DEVICE_NAME[i].name;
            str += "</option>";
        } else {
            if (+R_DEVICE_NAME[i].zone > 0) {
                str += '<option value="' + i + '" ';
                if (data == i) {
                    str += " selected ";
                }
                str += " >";
                str += R_DEVICE_NAME[i].name;
                str += "</option>";
            }
        }
    }

    str += "</select>";
    return str;
}

function delaySection_DISABLED(typeLW, param) {
    // В случае если задержки нет возвращает true 
    let type = typeLW + '_' + param;
    let delay = {};
    switch (type) {
        case "5_0":
            delay = { "yes": true, "time": "" };
            return delay;
            break;
        case "5_0D":
            delay = { "yes": false, "time": 90 };
            return delay;
            break;
        case "5_4":
            delay = { "yes": false, "time": 90 };
            return delay;
            break;
        case "5_2":
            delay = { "yes": true, "time": "" };
            return delay;
            break;
        case "5_8":
            delay = { "yes": true, "time": "" };
            return delay;
            break;
        case "5_10":
            delay = { "yes": true, "time": "" };
            return delay;
            break;
        case "5_1":
            delay = { "yes": true, "time": "" };
            return delay;
            break;

        case "noused":
            delay = { "yes": true, "time": "" };
            return delay;
            break;
        default:
            delay = { "yes": true, "time": "" };
            return delay;
            console.log("unknown type zone");
    }

}



function recoverTypeZone(elem) {
    if (elem.id.indexOf('recoveryLw_Tabl') != -1) {
        // после проверки того что произошел вызов из таблицы разделов
        modal_r_device_setTypeZone(elem.parentElement.parentElement.getElementsByTagName('select')[0]); //Вытаскиваем Тип зоны и отправляем её на сохранение
    }

}


function modal_r_device_setTypeZone(data) {
    let idDelay, idRecover, keyLW, who = '';
    let idRecover_Val = null;

    if (data.id.indexOf('modal_r_device_zone_type_S_') != -1) {
        who = 'table';
        keyLW = 'lw' + data.id.slice(27); // номер ключа 
        idDelay = 'delay_S_' + data.id.slice(27); // ID задержки
        idRecover = 'recoveryLw_Tabl_' + data.id.slice(27); // ID восстановление
    } else if (data.id.indexOf('modal_r_device_zone_type_E_') != -1) {
        who = 'ext';
        keyLW = 'lw' + data.id.slice(27); // номер ключа 
        idDelay = 'delayZoneExt_' + data.id.slice(27); // ID задержки
        idRecover = 'recoveryLw_Tabl_' + data.id.slice(27); // ID восстановление
    } else {
        who = 'card';
        idDelay = data.name;
    }

    switch (data.value) {
        case "5_0":
            if (document.getElementById(idDelay)) {
                idRecover_Val = "0";
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
            }
            break;
        case "5_0D":
            if (document.getElementById(idDelay)) {
                idRecover_Val = "0";
                document.getElementById(idDelay).value = 90;
                document.getElementById(idDelay).disabled = false;
            }
            break;

        case "5_4":
            if (document.getElementById(idDelay)) {
                idRecover_Val = "4";
                document.getElementById(idDelay).value = 90;
                document.getElementById(idDelay).disabled = false;
            }
            break;
        case "5_2":
            if (document.getElementById(idDelay)) {
                idRecover_Val = "2";
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
            }
            break;
        case "5_8":
            if (document.getElementById(idDelay)) {
                idRecover_Val = "8";
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
            }
            break;
        case "5_10":
            if (document.getElementById(idDelay)) {
                idRecover_Val = "10";
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
            }
            break;
        case "5_1":
            if (document.getElementById(idDelay)) {
                idRecover_Val = "1";
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
            }
            break;
        case "5_32":
            if (document.getElementById(idDelay)) {
                idRecover_Val = "32";
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
                //document.getElementById(idRecover).disabled = false;                
            }
            break;
        case "4_2":
            if (document.getElementById(idDelay)) {
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
                //document.getElementById(idRecover).disabled = false;
                idRecover_Val = "3";
            }
            break;
        case "2_2":
            if (document.getElementById(idDelay)) {
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
                //document.getElementById(idRecover).disabled = false;
                idRecover_Val = function () { if (document.getElementById(idRecover).checked) { return "3" } else { return "2" } }();
            }
            break;
        case "2_5":
            if (document.getElementById(idDelay)) {
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
                //document.getElementById(idRecover).disabled = false;
                idRecover_Val = function () { if (document.getElementById(idRecover).checked) { return "5" } else { return "4" } }();
            }
            break;

        case "2_8":
            if (document.getElementById(idDelay)) {
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
                //document.getElementById(idRecover).disabled = false;
                idRecover_Val = function () {
                    if (document.getElementById(idRecover).checked) {
                        return "9"
                    } else {
                        return "8"
                    }
                }();
            }
            break;

        case "noused":
            if (document.getElementById(idDelay)) {
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
            }
            break;
        default:
            if (document.getElementById(idDelay)) {
                document.getElementById(idDelay).value = "";
                document.getElementById(idDelay).disabled = true;
            }
            console.log("Type zone " + data.value + " not identified");
    }

    if (who === 'table') {
        // Сохранение типа зоны в таблице разделы
        let typeLW = '';
        if (data.value !== null) {
            typeLW = data.value.replace("D", ""); // Убираем из Охр. с фикс. зад. D
            typeLW = data.value.replace("noused", "1"); // Заменяем неиспользуемое на 0
        }

        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key === keyLW) {
                if (keyLW !== 'lw') { //проверяем что ключ зоны корректен          
                    deviceJSON.config[i].subvalues[0].value = typeLW.charAt(0);
                    let parametrLW = null;
                    if (typeLW === '0') {
                        if (idRecover_Val !== null) {
                            parametrLW = idRecover_Val;

                        } else {
                            parametrLW = "0";
                        }
                        deviceJSON.config[i].subvalues[1].value = parametrLW;
                        // deviceJSON.config[i].subvalues[1].value = "0"; Вернуть если план с рекавери провалился
                        deviceJSON.config[i].subvalues[2].value = function () { if (document.getElementById(idDelay).value === '') { return '0' } else { return document.getElementById(idDelay).value } }();
                        // если зона не Используется
                    } else {
                        //                        deviceJSON.config[i].subvalues[1].value = typeLW.slice(2);
                        let parametrLW = null;

                        if (idRecover_Val !== null) {
                            parametrLW = idRecover_Val;

                        } else {
                            parametrLW = "0";
                        }

                        deviceJSON.config[i].subvalues[1].value = parametrLW;
                        deviceJSON.config[i].subvalues[2].value = function () { if (document.getElementById(idDelay).value === '') { return '0' } else { return document.getElementById(idDelay).value } }();
                    }
                }
                saveConfig(deviceJSON.config[i]);
                parseAppKey("update_notabs");
            }
        }
    }
}

function checkRecoverZone(type, param) {
    type = +type;
    param = +param;
    if (type === 2 && param === 3) {
        return true
    } else if (type === 2 && param === 5) {
        return true
    } else if (type === 2 && param === 9) {
        return true
    } else {
        return false
    }

}

function swapSectionDelay(data) {
    let keyLw = "lw" + data.id.slice(8);
    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key === keyLw) {
            deviceJSON.config[i].subvalues[2].value = data.value;
            saveConfig(deviceJSON.config[i]);
            parseAppKey("update_notabs");
        }
    }
}


function section_list_add_zone(numberSections) {
    console.log(numberSections);
}

function section_create_list(data) {
    let secNumber = data.subvalues[0].value;
    let sensorNumber = data.key.slice(2);

    if (data.subvalues[0].value != "") {
        let nameLw = "lw" + sensorNumber + "_0";
        let type = dataDevice[nameLw].value;
        list_section[secNumber] = { free: false, type: type, sensors: [] };
        list_section[secNumber].sensors.push(sensorNumber);
    }
}


function search_mod_xxpg(data) {
    let ERROR_KEY = false;
    if (dataDevice['xxcc_0']) {
        if (dataDevice['xxcc_0'].value < 3 || dataDevice['xxcc_1'].value == 0) {
            ERROR_KEY = true;
            document.getElementById('modal_conf_toDev').style.display = 'none';
            $.modal('#modal_error_core');
            document.getElementById('modal_error_text').innerHTML = ERROR_DSC_XXCC;
            let elmMenu = document.getElementsByClassName('tab_r_device');
            for (var i = 0; i < elmMenu.length; i++) {
                elmMenu[i].click();
            }
        }
    }



    ///////////////////////
    if (!ERROR_KEY) {
        let adres = data;
        let lock = false;
        KEYFORSAVE.forEach(function (item, i, arr) {
            if (item.key == "xxad" + adres) {
                lock = true;
            }
        });

        if (!lock) {
            $.hide("#modal_no_connect_XXAD");
            spiner_start();
            initSearchRadio = adres; // Включен поиск РК датчика 
            getQuerty(vhost + CMD_SEARCH_RADIO + adres);

            setTimeout("spiner_stop()", 30000);
            setTimeout("initSearchRadio_stop()", 30000);
            modal_progres_detected();
        } else {
            document.getElementById("modal_no_connect_XXAD_number").innerHTML = adres;
            $.modal("#modal_no_connect_XXAD");
        }
    }
}

function initSearchRadio_stop() {
    initSearchRadio = false; // Выключили режим поиска РК датчика
}

function modal_progres_detected(time) {
    if (time < 100 || !time) {
        if (!time) {
            time = 0;
        } else { }
        time = time + 10;
        setTimeout("modal_progres_detected(" + time + ")", 1000);
        $.modal("#modal_progres_detected");
        document.getElementById("modal_progres_detected_text_cancel").innerHTML = "Поиск датчика . . ";
        document.getElementById("continBarDetected").style.width = time + "%";
    } else if (time >= 100) {
        $.hide("#modal_progres_detected");
    }
}

// function checkCorrectZon(data) {
//   if (data.value > 192) {
//     data.value = 192;
//   }
//   if (data.value < 1) {
//     data.value = 1;
//   }

//   if (data.id == "adresZone_1") {
//     let numberZone1 = document.getElementById("adresZone_2") ? document.getElementById("adresZone_1").value : null;
//     let numberZone2 = document.getElementById("adresZone_2") ? document.getElementById("adresZone_2").value : null;
//     if (numberZone1 == numberZone2) {
//       data.value = pickUpYzLw("lw", "2")[0];
//     }
//   }

//   if (data.id == "adresZone_2") {
//     let numberZone1 = document.getElementById("adresZone_1") ? document.getElementById("adresZone_1").value : null;
//     let numberZone2 = document.getElementById("adresZone_1") ? document.getElementById("adresZone_2").value : null;
//     if (numberZone1 == numberZone2) {
//       data.value = pickUpYzLw("lw", "2")[1];
//     }
//   }
// }

function swapSectionNumber(data) {
    console.log(data.parentElement.parentElement);
    let trElem = data.parentElement.parentElement;
    let idElem = data.id;
    //trElem.style.background = 'red';
    trElem.classList = 'focusEditsect';
    let keyYz = 'yz' + data.id.slice(7);
    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key === keyYz) {
            deviceJSON.config[i].subvalues[0].value = data.value; // номер первого зоны        
            saveConfig(deviceJSON.config[i]);
        }
    }
    setTimeout('focusEditSections(' + idElem + ')', 1000)
}

function focusEditSections(id) {
    parseAppKey("update_notabs");
    document.getElementById(id.id).focus();
    document.getElementById(id.id).parentElement.parentElement.classList = 'focusEditsect';
    setTimeout('document.getElementById("' + id.id + '").parentElement.parentElement.classList = "";', 1000)
}


function sectionZoneList(numberZone, value) {
    let str = '';
    str += '<select onchange="swapSectionNumber(this)" id="sect_S_' + numberZone + '" name="' + numberZone + '" >';
    // str += '<option value="" '
    // if (value === '') {
    //   str += ' selected ';
    // }
    // str += '> - </option>';

    for (var i = 1; i <= DEVICEINFO[DEVICEMODEL].sections; i++) {
        str += '<option '
        if (+value === i) {
            str += ' selected ';
        }
        str += '>';
        str += i + '</option>';
    }
    str += '</select>';

    return str;
}

function typeZoneList(numberZone, type, param) {
    let str = '';
    let typeName = {
        1: "Охранный с задержкой",
        2: "Охранный без задержки",
        3: "Охранный без задержки с контролем взлома извещателей",
        4: "Охранный проходной",
        5: "Охранный проходной с контролем взлома",
        6: "Охранный КТС",
        7: "Шлейф исключен",
        8: "Пожарный тип 1",
        9: "Пожарный тип 2",
        10: "Пожарный тип 3",
        11: "Пожарный тип 1 с контр. сбросом",
        12: "Пожарный тип 2 с контр. сбросом",
        14: "Патруль",
        15: "Управление разделом",
        16: "Охранный с фиксированной задержкой",
        17: "Газ",
        18: "Вода"
    }
    str += '<select name="' + numberZone + '" >';
    str += '<option value="0" '
    if (param === '' && param !== '0') {
        str += ' selected ';
    }
    str += '> - </option>';

    for (var i = 1; i <= 18; i++) {
        str += '<option '
        if (+param === i) {
            str += ' selected ';
        }
        str += '>';
        str += typeName[i] + '</option>';
    }
    str += '</select>';

    return str;
}


function saveModalRadio() {
    if (CACHE_EDIT_R_DEVICE.id === '-1') {
        saveModalRadio_NEW(); // Добавление новго устройства
    } else if (CACHE_EDIT_R_DEVICE.id === 'thisDevice') {
        saveModalIntegrationZone();
    } else {
        //saveModalRadio_EDIT(); // Редактирование устройства
        saveModalRadio_NEW(); // Добавление новго устройства
    }
}

function closeModalR_dev() {
    // Закрытие карточки радиоканального прибора
    document.getElementById('modal_r_device').style.display = 'none';
    // Чистим кэш
    CACHE_EDIT_R_DEVICE.id = null;
    CACHE_EDIT_R_DEVICE.numberSection = null;
    CACHE_EDIT_R_DEVICE.serial = null;

}



function saveModalRadio_EDIT() {

}

function saveModalRadio_REMOVE() {
    let CARD_DEVICE = {
        id: null, //Номер XXAD
        typeDevice: null, //Тип устройства
        numberZone_1: null, //Номер зоны 1
        numberZone_2: null, //Номер зоны 2
        typeZone_1: null, //Тип зоны 1
        typeZone_2: null, //Тип зоны 2
        delayZone_1: null, // Задержка зоны 1
        delayZone_2: null, // Задержка зоны 2
        sectionZone_1: null, // Раздел зоны 1
        sectionZone_2: null, // Раздел зоны 2
        typeESOP: null
    }
    //  CARD_DEVICE.id = deviceJSON.config[i].key; //????????????????


    // ▼ Тип устройства ▼
    CARD_DEVICE.typeDevice = document.getElementById('modal_r_device_name').value;
    // ▼ Номер зоны 1 ▼
    CARD_DEVICE.numberZone_1 = document.getElementById('adresZone_1') ? document.getElementById('adresZone_1').value : null;
    // ▼ Номер зоны 2 ▼
    CARD_DEVICE.numberZone_2 = document.getElementById('adresZone_2') ? document.getElementById('adresZone_2').value : null;
    // ▼ Тип зоны 1 ▼
    CARD_DEVICE.typeZone_1 = document.getElementById('modal_r_device_zone_type_1') ? document.getElementById('modal_r_device_zone_type_1').value : null;
    // ▼ Тип зоны 2 ▼
    CARD_DEVICE.typeZone_2 = document.getElementById('modal_r_device_zone_type_2') ? document.getElementById('modal_r_device_zone_type_2').value : null;
    // ▼ Задержка зоны 1 ▼
    CARD_DEVICE.delayZone_1 = document.getElementById('modal_r_device_zone_delay_1') ? document.getElementById('modal_r_device_zone_delay_1').value : null;
    // ▼ Задержка зоны 2 ▼
    CARD_DEVICE.delayZone_2 = document.getElementById('modal_r_device_zone_delay_2') ? document.getElementById('modal_r_device_zone_delay_2').value : null;
    // ▼ Раздел зоны 1 ▼
    CARD_DEVICE.sectionZone_1 = document.getElementById('nomberZone_Section_1') ? document.getElementById('nomberZone_Section_1').value : null;
    // ▼ Раздел зоны 2 ▼
    CARD_DEVICE.sectionZone_2 = document.getElementById('nomberZone_Section_2') ? document.getElementById('nomberZone_Section_2').value : null;



    let keyXXAD = 'xxad' + CACHE_EDIT_R_DEVICE.id;
    let keyXXDR = 'xxdr' + CACHE_EDIT_R_DEVICE.id;
    let keyLw1 = 'lw' + CARD_DEVICE.numberZone_1; // Ключ номера зоны 1
    let keyLw2 = 'lw' + CARD_DEVICE.numberZone_2; // Ключ номера зоны 2
    let keyYz1 = 'yz' + CARD_DEVICE.numberZone_1; // Ключ номера раздела 1
    let keyYz2 = 'yz' + CARD_DEVICE.numberZone_2; // Ключ номера раздела 2

    if (!false) {
        for (i in deviceJSON.config) {
            if (deviceJSON.config[i].key === keyXXAD) {
                // XXAD
                deviceJSON.config[i].subvalues[0].value = "0"; // Тип устройства согласно ЕСОП
                deviceJSON.config[i].subvalues[1].value = "0"; // Модель устройства 
                deviceJSON.config[i].subvalues[2].value = "0"; // Serial устройства 
                saveConfig(deviceJSON.config[i]);
            }

            if (deviceJSON.config[i].key === keyXXDR) {
                // XXDR
                deviceJSON.config[i].subvalues[0].value = "0"; // Тип устройства согласно ЕСОП
                deviceJSON.config[i].subvalues[1].value = "0"; // Модель устройства 
                saveConfig(deviceJSON.config[i]);
            }
            //LW
            if (deviceJSON.config[i].key === keyLw1 || deviceJSON.config[i].key === keyLw2) {
                deviceJSON.config[i].subvalues[0].value = "0"; // Тип устройства согласно ЕСОП
                deviceJSON.config[i].subvalues[1].value = "0"; // Модель устройства 
                deviceJSON.config[i].subvalues[2].value = "0"; // Модель устройства 
                saveConfig(deviceJSON.config[i]);
            }
            //YZ
            if (deviceJSON.config[i].key === keyYz1 || deviceJSON.config[i].key === keyYz2) {
                deviceJSON.config[i].subvalues[0].value = "0";
                saveConfig(deviceJSON.config[i]);
            }

        }
    }
    console.log(CARD_DEVICE);
    parseAppKey("update_notabs");
    closeModalR_dev(); // Чистим кэш и закрывем карточку

}

function setNameZone(data) {
    console.log(data.name + '  ' + data.value);
    for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key === data.name) {
            deviceJSON.config[i].subvalues[0].value = data.value;
            saveConfig(deviceJSON.config[i]);
            parseAppKey("update_notabs");
        }
    }
}

function check_mac_radio() {
    let locked = false;
    let title = '';
    let collection_block_el = document.getElementsByClassName('radio_parametr_input');
    if (virtualRadio.length > 0) {
        locked = true;
        title = 'Настройка заблокирована, для изменения удалите радиоканальные устройства';
    } else {
        locked = false;
        title = '';
    }
    for (var i = 0; i < collection_block_el.length; i++) {
        collection_block_el[i].disabled = locked;
        collection_block_el[i].title = title;
    }
}